/*
Programmé par Maniack Crudelis.
http://www.crudelis.fr.tc
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
*/

#ifndef MENU_H
#define MENU_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Utilitaire.h"
#include "Fichier.h"

char* Menu (const char* nomfichier, char* lecture, int quitD, int defaut);  //Gère un fichier de menu
//Nomfichier est le nom du menu
//lecture est renvoyé en réponse du menu
//quitD à 1 pour quitter directement sur q
//defaut à 1 pour accepter l'appui sur entrée direct, ce qui renvoi "defaut" à l'appelant
void Menu_dossier (const char* dossier, const char* nom_menu, const char* filtres); //Créer un menu à partir d'un dossier
//filtres permet d'affecter 1 ou plusieurs filtres de fichiers. De la manière suivante: txt:html:txtp, pour n'utiliser aucun filtres, noter une chaine vide

char* Menu (const char* nomfichier, char* lecture, int quitD, int defaut)
{
    FILE* temp;
    FILE* FichierMenu;
    int i, choix=-1; /*Valeur par defaut pour choix*/
    char menu='1';
    char affich [255];
    FichierMenu = ouvre_fichier(nomfichier,"r");
    while (feof(FichierMenu) == 0)
    {
        fgets(lecture,255,FichierMenu);
        if ((strstr(lecture,"menu=") != NULL) && (menu==lecture[5]))   /*Si le menu correspondant est trouvé*/
        {
            temp = ouvre_fichier("menu.tmp","w");        /*Fichier temporaire*/
            fgets(lecture,250,FichierMenu);
            printf("\n%s", acc(lecture,chfunc));            /*Titre du menu*/
            fgets(lecture,250,FichierMenu);
            while((strstr(lecture,"menu=") == NULL) && (feof(FichierMenu) == 0))
            {                  /*Tant que le menu n'est pas complètement lu*/
                fprintf(temp,"%s",lecture);  /*Inscrit le menu dans le fichier temporaire*/
                i=0;
                while (lecture[i] != ':')
                {
                    affich[i] = lecture[i];
                    i++;
                }
                affich [i] = '\0';
                printf("%s\n", acc(affich,chfunc));  /*Affiche le menu à l'écran*/
                fgets(lecture,250,FichierMenu);
            }
            fclose(temp);
            temp = ouvre_fichier("menu.tmp","r");  /*Lit le menu actuel dans le fichier temporaire*/
            printf("?: ");
            choix = chiffre_lettre(0);   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
            {
                fclose(temp);
                fclose(FichierMenu);
                if(quitD)  //Si quitD == 1, autorisation de quitter directement
                    exit(0);
                else
                {
                    strcpy(lecture,"q");
                    return (lecture); //Sinon, quitD == 0, il renvoi la commande quit au programme qui l'a appelé
                }
            }
            if (choix == NA) /*Si l'utilisateur presse entrée*/
            {
                if(!defaut) //defaut == 0, le programme appelant n'accepte pas de valeur par défaut
                    choix = -2;    /*Choix prend -2, ce qui renverra à Fuck*/
                else
                {
                    strcpy(lecture,"defaut");
                    return (lecture);    //sinon defaut == 1, le programme prend l'appui sur entrée.
                }
            }
            while (feof(temp) == 0)
            {
                fgets(lecture,250,temp);
                Efface_n(lecture);      //Retire le \n
                if (atoi(lecture) == choix)   /*Vérifie que le nombre correspond au choix*/
                {
                    fclose(temp);
                    Efface_char(lecture,":");
                    if (strstr(lecture,"menu-") == NULL)
                    {                /*Si c'est ne pas un changement de menu*/
                        fclose(FichierMenu);
                        return (lecture);   /*Renvoi la saisi (sans le : et le retour ligne*/
                    }
                    menu = lecture[5];     /*Lit le numero du menu*/
                    rewind(FichierMenu);
                    choix = -1;
                    break;
                }
            }
            if (choix != -1)
            {
                Fuck();
                rewind(FichierMenu);
            }
        }
    }
    printf("Erreur dans le fichier de menu, le menu %c n'a pas %s\n", menu, acc("été trouvé.",chfunc));
    fclose(temp);
    fclose(FichierMenu);
    DPause();
    if(quitD)  //Si quitD == 1, autorisation de quitter directement
        exit(0);
    else
    {
        strcpy(lecture,"q");
        return (lecture); //Sinon, quitD == 0, il renvoi la commande quit au programme qui l'a appelé
    }
}

void Menu_dossier (const char* dossier, const char* nom_menu, const char* filtres)
{
    FILE* temp;
    FILE* menu;
    char lecture[4096];
    char titre[4096];
    int cptmenu=1, entree=1;
    temp = ouvre_fichier("temp.tmp","w");
    listing_doss(dossier,temp,0,filtres,0); //Appel la commande de listing de dossier pour lister le contenu du dossier des menus
    //Pour plus tard, Utiliser le scan récursif pour créer des menus imbriqués.
    fclose(temp);
    menu = ouvre_fichier(nom_menu,"w");
    temp = ouvre_fichier("temp.tmp","r");
    fprintf(menu,"menu=%d\n", cptmenu);
    fprintf(menu,"%s\n", dossier);
    while(fgets(lecture,255,temp))
    {
        Efface_n(lecture);
        strcpy(titre,lecture);
        #ifdef WIN32    //win
        Efface_char(titre,"\\");
        #else//linux
        Efface_char(titre,"/");
        #endif
        fprintf(menu,"%d) %s.:%s\n", entree++, titre,lecture);
    }
    fclose(temp);
    fclose(menu);
}

#endif

