/* Programme de gestion de combattants pour donjons et dragons 3.5.
Programm par Maniack Crudelis.
http://www.crudelis.fr
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 2.6.2. */
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#define MAXCOMB 51 //Nombre maximum de combattant
#define MAXARMES 21 //Nombre maximale d'armes pour chaque combattant

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "Utilitaire.h"
#include "Rand.h"
#include "Jdr.h"

struct donnees_combat         /*Structure de donnes*/
{
    char nom[MAXCOMB][255];  /*Nom des combattants*/
    char degats[MAXCOMB][MAXARMES][255];  /*Dgts pour chacune des armes*/
    char* notes[MAXCOMB];   //Notes sur le combattant
    int battaques[MAXCOMB][MAXARMES][20];  /*jets d'attaques pour les armes diffrentes*/
    int armesmult[MAXCOMB][MAXARMES][20];  //Liste des armes pour les attaques  armes multiples
    int defaut[MAXCOMB][2];  /*Saisie par defaut: esquive, rsistance*/
    int init[MAXCOMB];   /*Jet d'initiative*/
    int tpv[MAXCOMB];    //Points de vie
    int pv[MAXCOMB];     //Points de vie actuels
    char DV[MAXCOMB][255];  //Ds de vie
    int bonus_pv[MAXCOMB];     //Bonus de pv au DV
    int malus[MAXCOMB];  //Malus li au stade de blessure
    int etat[MAXCOMB];   //Etat du combattant (Stade de blessure)
    int hors_combat[MAXCOMB]; //Rpertorie les combattants dans le coma ou morts
    int num;    //Numro d'identifiant du combattant
    int crit_tete[2];  //Indique si l'attaque effectue un potentiel critique et/ou une touche  la tte
    int arme0[MAXCOMB][MAXARMES][6];    //Dtails sur les armes: 0:init; 1:nb attaques; 2:critique; 3:bonus dgts; 4:bonus perforation; 5:1=arme simple, 2=armes multiples (La dernire arme est l'arme vide contenant des valeurs par dfaut)
    char nom_arme[MAXCOMB][MAXARMES][255];  //Nom des armes utilises par chaque combattant
    char effet_arme[MAXCOMB][MAXARMES][255];  //Effet supplmentaire ventuel des armes
    int arme[MAXCOMB];   //Numro de l'arme utilise
};

int interpret_attaque(char *attaque, int *bonus_att, struct donnees_combat *cmb); /*Interprete les bonus d'attaques, et stocke les diffrents bonus dans le tableau, renvoi le nombre de jets*/
void degats (struct donnees_combat *cmb); //Gre les dgts, les critiques et les coups  la tte
void attaque_simple (struct donnees_combat *cmb); //Gre la procdure d'attaque
void store_combattants (struct donnees_combat *cmb); //Ecrit le fichier texte contenant les combattants
void get_combattants (struct donnees_combat *cmb); //Lit le fichier texte contenant les combattants
void Etat_combattant (struct donnees_combat *cmb); //Dtermine l'tat de blessure du combattant en fonction de ses points de vie
int saisie_pv (struct donnees_combat *cmb);   //Gre l'appel au programme de calcul de pv si ncessaire.
void choix_arme (struct donnees_combat *cmb); //Choix de l'arme  utiliser par le combattant
void Quitter (struct donnees_combat *cmb); //Quitte proprement le programme
void duplicateComb (struct donnees_combat *cmb); //Duplique le combattant

int main (int argc,char *argv[])
{
    FILE* sortie;
    struct donnees_combat cmb;
    char saisie[50];
    char chaine[255];
    char* chaine_dyn_mod[1];
    int copie_battaques[20];
    int i,j,k,passe,lligne;
    Init_srand();
    init_historique_saisie();
    p35=0;  //Par dfaut, rgles 3.5 mod
    if(argc > 1)
    {
        Efface_char(argv[1],"=");
        p35 = atoi(argv[1]);    //Gre la version des rgles  utiliser
    }
    #ifdef WIN32    /*win*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    if(p35)
        Titre(argc,argv,"Gestion combattant","Programme de simplification des combats 3.5",color_sd("Gestion combattant 3.5",chfunc,argv));
    else
        Titre(argc,argv,"Gestion combattant","Programme de simplification des combats",color_sd("Gestion combattant",chfunc,argv));
    #ifndef WIN32    /*linux*/
        Ph_jdr("..\\Phrases de jdr.txt");
    #endif
    /*Initialisation des tableaux*/
    for(i=0;i<MAXCOMB;i++)
        cmb.nom[i][0] = '\0';
    for(i=0;i<MAXCOMB;i++)
    {
        for(j=0;j<4;j++)
            cmb.defaut[i][j] = 0;
    }
    get_combattants(&cmb);      //Lecture du fichier des combattants
    do
    {
printf("\nInit combattant 1:%d / %d\n", cmb.arme0[0][cmb.arme[0]][0], cmb.init[0]);
        printf("Ajouter un nouveau combattant: N\n");
        putsacc("Supprimer un combattant: S suivi du numro du combattant  supprimer\n");
        putsacc("Modifier un combattant: M suivi du numro du combattant  modifier\n");
        printf("Round suivant (nouveau jet d'initiative): R\n");
        putsacc("Blesser ou soigner un combattant: P suivi du numro du combattant (ou Px-y/Px+y)\n");
        putsacc("Grer les armes d'un combattant: A suivi du numro du combattant\n");
        putsacc("Dupliquer un combattant: dp suivi du numro du combattant  dupliquer\n");
        putsacc("Re-gnrer les PV: rp suivi du numro du combattant pour lequel recaculer les PV\n");
        putsacc("Attaquer avec un combattant: Indiquer simplement le numro du combattant!\n\n");
        putsacc("'Numro du combattant' 'Nom' ('Initiative'; 'Points de vie','Etat')\n\n");
        passe=0;
        do
        {   //L'affichage des combattants se fait en 2 passes, une premire pour afficher les combattants valides, un seconde pour les invalides.
            passe++;
            if(passe==2)
            {
                for(i=0;i<MAXCOMB;i++)
                {
                    if(cmb.nom[i][0] != '\0' && cmb.hors_combat[i])
                    {
                        printf("\n>\n");
                        break;
                    }
                }
            }
            i=0;
            k=0;
            lligne=0;
            while(i<MAXCOMB)
            {   /*Affiche les diffrents combattants*/
                if(cmb.nom[i][0] != '\0')
                {
                    if(passe==1)
                    {   //Pour la premire passe, on repertorie les combattants hors combat
                        if(cmb.etat[i] == 'x' || cmb.etat[i] == 't')
                        {   //Si le combattant est dans le coma ou mort.
                            cmb.hors_combat[i] = 1; //Place le combattant hors combat
                            i++;
                            continue;   //Passe au combattant suivant
                        }
                        else
                            cmb.hors_combat[i] = 0; //Le combattant est encore apte au combat
                    }
                    if(passe==2)
                    {   //Pour la seconde passe, on rejette tous les combattants valides
                        if(!cmb.hors_combat[i])
                        {
                            i++;
                            continue;
                        }
                    }
                    sprintf(chaine,">%d) %s (%d; %d,", i+1, acc(cmb.nom[i],chfunc), cmb.init[i], cmb.pv[i]);
                    if(cmb.etat[i] > 0)
                        sprintf(saisie,"%c)", cmb.etat[i]);
                    else
                        sprintf(saisie,"%d)", cmb.etat[i]);
                    strcat(chaine,saisie);
                    if(lligne+strlen(chaine) <= MAX_LARGEUR_TERM+1) //Si l'affichage du combattant ne dpassera pas de la ligne
                    {
                        printf("%s", chaine); //Affiche le combattant
                        lligne += strlen(chaine);
                    }
                    else
                    {
                        printf("\n%s", chaine); //Sinon affiche  la ligne suivante
                        lligne=strlen(chaine);    //Rinitialise lligne
                    }
                    if(lligne+5 <= MAX_LARGEUR_TERM+1)
                    {
                        printf("     ");
                        lligne+=5;
                    }
                }
                i++;
            }
        }while(passe<2);
        printf("\n?: ");
        strcpy(saisie,nomajloc_gestion_combattant(chfunc,0));
        if(saisie[0]=='q')
            Quitter(&cmb);
        if(saisie[0] == '\0')   /*Si aucune entre*/
            continue;
        else if(saisie[0] == 'd' && (saisie[1] == 'p' || saisie[1] == 'P'))
        {   //dpX duplication de combattant
            if(!isdigit(saisie[2]))
                continue;  //Retourne au menu si la commande est mal saisie
            saisie[1] = 'p';    //S'assure que c'est un p minuscule
            Efface_char(saisie,"dp");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            duplicateComb(&cmb);
            store_combattants(&cmb);
        }
        else if(saisie[0] == 'A')
        {   //Changer d'arme
            if(!isdigit(saisie[1]))
                continue;  //Retourne au menu si la commande est mal saisie
            Efface_char(saisie,"A");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            choix_arme(&cmb);
        }
        else if(saisie[0] == 'm' || saisie[0] == 'M')
        {   /*Modifier combattant*/
            if(!isdigit(saisie[1]))
                continue;  //Retourne au menu si la commande est mal saisie
            saisie[0] = 'M';    /*S'assure que c'est un M majuscule*/
            Efface_char(saisie,"M");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            printf("Modification du combattant ");
            if(cmb.num < 9)
                printf("0");
            printf("%d\n", cmb.num+1);
            putsacc("Nom du combattant ");
            printf("(Defaut=%s): ", acc(cmb.nom[cmb.num],chfunc));
            getsfix(chaine,255);
            if(chaine[0] != '\0')   /*Si un nouveau nom est entr*/
                strcpy(cmb.nom[cmb.num],chaine);
            putsacc("Pour des attaques multiples, noter +x/+x etc. Pour grer les armes noter A.\n");
            printf("Bonus d'attaque (Defaut:");
            for(i=0;i<cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] && i<20;i++) /*bcl sur le nombre d'attaque pour l'affichage*/
            {
                if(i>0)
                    printf("\\");
                if(cmb.battaques[cmb.num][cmb.arme[cmb.num]][i] >= 0)
                    printf("+");
                printf("%d", cmb.battaques[cmb.num][cmb.arme[cmb.num]][i]);
            }
            printf("): +");
            for(i=0;i<20;i++)
                copie_battaques[i] = cmb.battaques[cmb.num][cmb.arme[cmb.num]][i];  /*Copie de sauvegarde des jets d'attaque par defaut*/
            j = cmb.arme0[cmb.num][cmb.arme[cmb.num]][1];  /*Copie de sauvegarde du nombre de jets d'attaque par defaut*/
            cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] = interpret_attaque(saisie,cmb.battaques[cmb.num][cmb.arme[cmb.num]],&cmb);
            if(cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] == -1)  //Gestion des armes
            {
                cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] = j;  //Reprend la valeur normale
                choix_arme(&cmb);
            }
            else
            {   //Sinon gestion normale de l'arme en cours par utilisation des jets d'attaque puis du bonus d'init
                if(cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] == 0) /*Pas de saisie, valeur par defaut*/
                {   /*Reprend les copies*/
                    for(i=0;i<20;i++)
                        cmb.battaques[cmb.num][cmb.arme[cmb.num]][i] = copie_battaques[i];
                    cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] = j;
                }
                do
                {    /*Boucle d'erreur de saisie*/
                    printf("Modificateur d'initiative (Defaut=%d): +", cmb.arme0[cmb.num][cmb.arme[cmb.num]][0]);
                    j = (int) interpret_calc("\0",0);
                    if(j==QUIT)
                        Quitter(&cmb);
                } while (j == NA);
            }
            if(j != defo)  /*Si nouveau bonus d'initiative*/
                cmb.arme0[cmb.num][cmb.arme[cmb.num]][0] = j; /*Devient la valeur par defaut*/
            do
            {    /*Boucle d'erreur de saisie*/
                printf("Points de vie (Defaut=%d): ", cmb.tpv[cmb.num]);
                j = saisie_pv(&cmb);
                if(j==QUIT)
                    Quitter(&cmb);
            } while (j == NA);
            if(j != defo)  /*Si nouveau total de points de vie*/
            {
                cmb.tpv[cmb.num] = j; /*Devient la valeur par defaut*/
                cmb.pv[cmb.num] = j;
            }
            putsacc("Notes sur le combattant: ");
            printf("Defaut=%s\n", acc(cmb.notes[cmb.num],chfunc));
            printf("?: ");
            chaine_dyn_mod[0] = tabch_dyn(chaine_dyn_mod,0,stdin,0);
            if(chaine_dyn_mod[0][0] != '\0')   //Si de nouvelles notes sont entres*/
            {
                free (cmb.notes[cmb.num]);
                ER = (int) (cmb.notes[cmb.num] = (char*) calloc(strlen(chaine_dyn_mod[0]),sizeof(char)));  //Allocation du mme espace pour stocker la copie de la chaine saisie
                Erreur(1);
                strcpy(cmb.notes[cmb.num],chaine_dyn_mod[0]);
                free(chaine_dyn_mod[0]);
            }
            store_combattants(&cmb);
        }
        else if(saisie[0] == 'n' || saisie[0] == 'N')
        {   /*Nouveau combattant*/
            for(cmb.num=0;cmb.num<MAXCOMB;cmb.num++)
            {
                if(cmb.nom[cmb.num][0] == '\0')
                    break;  /*Cherche un espace libre pour le nouveau combattant*/
            }
            if(cmb.num>MAXCOMB-1)
                putsacc("Aucun espace disponible, supprimer des combattants au pralable\n");
            else
            {
                for(i=0;i<MAXARMES-1;i++)   //Initialise le nom des armes
                    cmb.nom_arme[cmb.num][i][0] = '\0';
                cmb.arme[cmb.num] = 0;   //Par dfaut, un nouveau combattant utilise l'arme 0
                strcpy(cmb.nom_arme[cmb.num][0],"_default_");
                printf("Nouveau combattant\n");
                putsacc("Nom du combattant: ");
                getsfix(chaine,255);
                strcpy(cmb.nom[cmb.num],chaine);
                putsacc("Pour des attaques multiples, noter +x/+x etc. Pour grer les armes noter A.\n");
                //Crer la dernire arme, l'arme de dfaut.
                cmb.nom_arme[cmb.num][MAXARMES-1][0] = '\0'; //Nom null.
                strcpy(cmb.degats[cmb.num][MAXARMES-1],"1d6"); //1d6 de dgts.
                cmb.arme0[cmb.num][MAXARMES-1][3] = 0;  //Bonus de dgts  0.
                cmb.arme0[cmb.num][MAXARMES-1][0] = 0; // Initiative de l'arme  0.
                cmb.arme0[cmb.num][MAXARMES-1][1] = 1; //1 seule attaque.
                cmb.battaques[cmb.num][MAXARMES-1][0] = 1; //Attaque  +1.
                cmb.arme0[cmb.num][MAXARMES-1][4] = 0; //Bonus de perforation de l'arme  0.
                cmb.arme0[cmb.num][MAXARMES-1][2] = 19; //Valeur de critique  19.
                cmb.arme0[cmb.num][MAXARMES-1][5] = 1; //Arme simple.
                cmb.effet_arme[cmb.num][MAXARMES-1][0] = '\0'; //Pas d'effet particulier pour cette arme.
                printf("Bonus d'attaque: +");
                cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] = interpret_attaque(saisie,cmb.battaques[cmb.num][cmb.arme[cmb.num]],&cmb);
                if(cmb.arme0[cmb.num][cmb.arme[cmb.num]][1] == -1)  //Gestion des armes
                {
                    choix_arme(&cmb);
                }
                else
                {   //Sinon gestion normale de l'arme en cours par utilisation des jets d'attaque et du bonus d'init
                    do
                    {
                        printf("Modificateur d'initiative: +");
                        cmb.arme0[cmb.num][cmb.arme[cmb.num]][0] = (int) interpret_calc("\0",0);
                        if(cmb.arme0[cmb.num][cmb.arme[cmb.num]][0]==QUIT)
                            Quitter(&cmb);
                    } while (cmb.arme0[cmb.num][cmb.arme[cmb.num]][0] == NA || cmb.arme0[cmb.num][cmb.arme[cmb.num]][0] == defo);
                }
                do
                {
                    printf("Points de vie: ");
                    cmb.tpv[cmb.num] = saisie_pv(&cmb);
                    if(cmb.tpv[cmb.num]==QUIT)
                        Quitter(&cmb);
                } while (cmb.tpv[cmb.num] == NA || cmb.tpv[cmb.num] == defo);
                cmb.pv[cmb.num] = cmb.tpv[cmb.num];
                putsacc("Notes sur le combattant: ");
                cmb.notes[cmb.num] = tabch_dyn(cmb.notes,cmb.num,stdin,0);
            }
            Etat_combattant(&cmb);  //Dtermine l'tat de blessure du combattant
            store_combattants(&cmb);
        }
        else if((saisie[0] == 'r' || saisie[0] == 'R') && (saisie[1] == 'p' || saisie[1] == 'P'))
        {   //Recalculer les PV du combattant en fonction de son nombre de DV
            if(!isdigit(saisie[2]))
                continue;  //Retourne au menu si la commande est mal saisie
            saisie[1] = 'P';    /*S'assure que c'est un P majuscule*/
            Efface_char(saisie,"P");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            if(cmb.DV[cmb.num][0] == '0')
            {   //Les DV ne sont pas renseigns
                putsacc("Les DV ne sont pas renseigns. Impossible de gnrer de nouveaux PV.\n");
                Pause();
            }
            else
            {   //Les DV sont renseigns, gnre de nouveau PV
                #ifdef WIN32    /*win*/
                sprintf(chaine,"cd \"..\\Programmes divers\" && PV.exe p35=%d  NbCreature=1 NbJet=3 Des=\"%s\" Bonus=%d Affichage=3", p35, cmb.DV[cmb.num], cmb.bonus_pv[cmb.num]);
                #else /*linux*/
                sprintf(chaine,"cd \"../Programmes divers\" && ./PV p35=%d  NbCreature=1 NbJet=3 Des=\"%s\" Bonus=%d Affichage=3", p35, cmb.DV[cmb.num], cmb.bonus_pv[cmb.num]);
                #endif
                system(chaine); //Appel le gnrateur de points de vie en ligne de commande
                sortie = ouvre_fichier("..\\Programmes divers\\Sortie_pv.txt","r");
                fgets(chaine,255,sortie);  //Lit le rsultat du gnrateur de points de vie
                Efface_char(chaine,": ");
                i = atoi(chaine); //Lit les nouveaux PV
                fclose(sortie);
                cmb.pv[cmb.num] = i;
                cmb.tpv[cmb.num] = i; //Et duplique sur le total
            }
            Etat_combattant(&cmb);  //Dtermine l'tat de blessure du combattant
        }
        else if(saisie[0] == 'r' || saisie[0] == 'R')
        {   /*Nouveau round*/
            puts("Nouveau round");
            for(i=0;i<MAXCOMB;i++)
            {
                if(cmb.nom[i][0] != '\0')   //Si le combattant existe, effectue son initiative
                    cmb.init[i] = NbAlea1b(20)+cmb.arme0[i][cmb.arme[i]][0];    /*Effectue les jets d'initiatives pour tous les combattants*/
            }
        }
        else if(saisie[0] == 's' || saisie[0] == 'S')
        {   /*Supprimer un combattant*/
            if(!isdigit(saisie[1]))
                continue;  //Retourne au menu si la commande est mal saisie
            saisie[0] = 'S';    /*S'assure que c'est un S majuscule*/
            Efface_char(saisie,"S");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  supprimer*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            cmb.nom[cmb.num][0] = '\0';   /*Supprime le combattant*/
            free (cmb.notes[cmb.num]);  //Libre la mmoire alloue aux notes sur le combattant
            printf("Suppression du combattant %d\n", cmb.num+1);
            store_combattants(&cmb);
        }
        else if(saisie[0] == 'p' || saisie[0] == 'P')
        {   //Blessure ou soin d'un combattant = modification des pv actuels
            if(!isdigit(saisie[1]))
                continue;  //Retourne au menu si la commande est mal saisie
            saisie[0] = 'P';    /*S'assure que c'est un P majuscule*/
            Efface_char(saisie,"P");
            cmb.num = atoi(saisie)-1; /*Lit le numro du combattant  modifier*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            if(strstr(saisie,"+") || strstr(saisie,"-"))
            {
                if(strstr(saisie,"+"))
                {
                    Efface_char(saisie,"+");
                    k=1;
                }
                if(strstr(saisie,"-"))
                {
                    Efface_char(saisie,"-");
                    k=-1;
                }
                k *= atoi(saisie);
            }
            else
            {
                printf("Points de vie actuels: %d [PV Totaux = %d]\n", cmb.pv[cmb.num], cmb.tpv[cmb.num]);
                do
                {
                    putsacc("Nombre de points de vie  retrancher ou ajouter: ");
                    k = (int) interpret_calc("\0",0);
                    if(k==QUIT)
                        Quitter(&cmb);
                } while (k == NA || k == defo);
            }
            cmb.pv[cmb.num] += k;   //Ajoute ou retranche les points de vie au combattant
            Etat_combattant(&cmb);  //Dtermine l'tat de blessure du combattant
        }
        else if(strstr(saisie,"d"))
        {   //Dtection d'un jet de ds dans la saisie
            puts("");
            #ifdef WIN32    /*win*/
            sprintf(chaine,"cd \"..\\Programmes divers\" && Simulateur_des.exe Des=\"%s\" Affichage=2", saisie);
            #else /*linux*/
            sprintf(chaine,"cd \"../Programmes divers\" && ./Simulateur_des Des=\"%s\" Affichage=2", saisie);
            #endif
            system(chaine); /*Appel le gnrateur de ds en ligne de commande*/
            Pause();
        }
        else if(isdigit(saisie[0]))
        {   /*Choix d'un combattant*/
            cmb.num = atoi(saisie)-1;   /*Lit le numro du combattant*/
            if(cmb.nom[cmb.num][0] == '\0')
                continue;  //Retourne au menu si le combattant n'existe pas
            if(cmb.notes[cmb.num][0] != '\0')   //Si il y a une note  afficher
            {
                printf("\n%s\n", cmb.notes[cmb.num]);
                printf("~\n");
            }
            printf("->Attaque de %s, combattant %d (", cmb.nom[cmb.num], cmb.num+1);
            switch (cmb.etat[cmb.num])
            {
                case 'I':
                    printf("Indemne");
                break;
                case 'x':
                    printf("Coma");
                break;
                case 't':
                    printf("Mort...");
                break;
                case 0:
                    printf("Egratignure");
                break;
                case -2:
                    putsacc("Blessure lgre");
                break;
                case -4:
                    printf("Blessure grave");
                break;
                case -6:
                    printf("Handicap");
                break;
                case -8:
                    putsacc("Hmorragie");
                break;
                case '/':   //Pur 3.5
                    putsacc("Bless");
                break;
            };
            printf(" %d/%d)\n\n", cmb.pv[cmb.num],cmb.tpv[cmb.num]);
            attaque_simple(&cmb);   /*Appel la fonction d'attaque*/
        }
        else    //Saisie non reconnue...
            continue;  //Retourne au menu
        puts("------------------------------------------------------------------------------");
    }while(1);
    return 0;
}

void degats (struct donnees_combat *cmb)
{
    int bonus, total, val, *des=NULL, i;
    char chaine[255];
    total=0;
    printf("\n%s (.d.) (Defaut:%s): ", acc("Jet de dgts:\nType de ds",chfunc), cmb->degats[cmb->num][cmb->arme[cmb->num]])   ;
    des = interpret_des(des,"0",chfunc);
    if(chfunc[0] == '\0')   //Valeur par dfaut, pas de saisie de l'utilisateur
        des = interpret_des(des,cmb->degats[cmb->num][cmb->arme[cmb->num]],chfunc); //Utilisation de la valeur par dfaut
    else    //Saisie par l'utilisateur des ds de dgts
        strcpy(cmb->degats[cmb->num][cmb->arme[cmb->num]],chfunc);   //Copie la saisie de l'utilisateur et devient la valeur par dfaut
    do
    {    /*Bcl erreur de saisie*/
        printf("Bonus de %s (Defaut=+%d): : +", acc("dgts",chfunc), cmb->arme0[cmb->num][cmb->arme[cmb->num]][3]);
        bonus = (int) interpret_calc("\0",0);
        if(bonus==QUIT)
            Quitter(cmb);
    } while (bonus == NA);
    if(bonus == defo)  /*Si pas d'entre, valeur par defaut*/
        bonus = cmb->arme0[cmb->num][cmb->arme[cmb->num]][3];
    else /*Si bonus spcifi*/
        cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] = bonus; /*Devient la valeur par defaut*/
    if(des[0] > 1)   //Si plusieurs ds de dgts, affiche les dtails de chaque ds
        putsacc("\nDtails des dgts: ");
    for (i=1;i<=des[0];i++)
    {    /*Calcul les dgts*/
        val = NbAlea1b(des[i]);
        if(des[0] > 1)   //Si plusieurs ds de dgts, affiche les dtails de chaque ds
            printf("%d  ", val);
        total += val;
    }
    printf("\nJet naturel= %d\n", total);
    printf("%s +%d\n", acc("Bonus de dgts",chfunc), bonus);
    if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][5]==2) //Dans le cas d'une attaque  armes multiples, utilise le nom de l'arme utilise dans l'attaque
    {
        strcpy(chaine,cmb->effet_arme[cmb->num][cmb->arme[cmb->num]]);  //Copie l'effet de l'arme, auquel est concatn le nom de l'arme
        Efface_char(chaine,"|");    //Isole le nom de l'arme dans chaine en retirant le dbut jusqu'au pipe
        cmb->effet_arme[cmb->num][cmb->arme[cmb->num]][index_ch_first(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],"|")] = '\0';  //Isole l'effet en terminant la chaine au pipe
        printf("%s", chaine);
    }
    else //Arme normale
        printf("%s", acc(cmb->nom_arme[cmb->num][cmb->arme[cmb->num]],chfunc)); //Utilise directement le nom de l'arme
    printf(": %d", total+bonus);
    if((total+bonus) > 1)
        putsacc(" dgts");
    else
        putsacc(" dgt");
    if(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]][0] != '\0')   //Si l'arme a un effet particulier
        printf(" +%s", acc(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],chfunc));
    puts("");
    if(cmb->crit_tete[0] || cmb->crit_tete[1])
        puts("");
    if(cmb->crit_tete[0])   //Si critique potentiel
    {
        if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] == 0)   //Critique non renseign
        {
            putsacc("\t(Sous rserve que l'arme effectue un jet critique sur ");
            printf("%d)\n", cmb->crit_tete[0]);
        }
        printf("->Critique *2= %d", total*2+bonus);
        if((total*2+bonus) > 1)
            putsacc(" dgts");
        else
            putsacc(" dgt");
        printf("\n->Critique *3= %d", total*3+bonus);
        if((total*3+bonus) > 1)
            putsacc(" dgts");
        else
            putsacc(" dgt");
        puts("");
    }
    if(cmb->crit_tete[1])   //Si attaque  la tte potentielle
    {
        putsacc("\t(Sous rserve que la localisation ");
        printf("%d", cmb->crit_tete[1]);
        putsacc(" corresponde  la tte)\n");
        printf("->Attaque %s= %d", acc(" la tte",chfunc), (total+bonus)*2);
        if(((total+bonus)*2) > 1)
            putsacc(" dgts");
        else
            putsacc(" dgt");
        puts("");
    }
    if(cmb->crit_tete[0] && cmb->crit_tete[1])   //Si critique  la tte potentiel !!!
    {
        if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] == 0)   //Critique non renseign
            putsacc("\t(Si les 2 conditions prcdentes sont valides)\n");
        else
            putsacc("\t(Si le critique  la tte est valid)\n");
        printf("->Critique *2 %s= %d", acc(" la tte",chfunc), (total*2+bonus)*2);
        if(((total*2+bonus)*2) > 1)
            putsacc(" dgts");
        else
            putsacc(" dgt");
        printf("\n->Critique *3 %s= %d", acc(" la tte",chfunc), (total*3+bonus)*2);
        if(((total*3+bonus)*2) > 1)
            putsacc(" dgts");
        else
            putsacc(" dgt");
        puts("");
    }
    free(des);
}

void attaque_simple (struct donnees_combat *cmb)
{
    int jet_perf, loc, i, esquiv, jet_att, bonus_perf, resist;
    char saisie[50];
    int copie_battaques[20];
    do
    {
        putsacc("Pour des attaques multiples, noter +x/+x etc. Pour grer les armes noter A.\n");
        if(strcmp(cmb->nom_arme[cmb->num][cmb->arme[cmb->num]],"_default_"))   //Si c'est l'arme par dfaut, pas d'affichage du nom de l'arme
            printf("%s: ", cmb->nom_arme[cmb->num][cmb->arme[cmb->num]]);
        printf("Bonus d'attaque (Defaut:");
        for(i=0;i<cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] && i<20;i++) /*bcl sur le nombre d'attaque pour l'affichage*/
        {
            if(i>0)
                printf("\\");
            if(cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] >= 0)
                printf("+");
            printf("%d", cmb->battaques[cmb->num][cmb->arme[cmb->num]][i]);
        }
        if(!p35)    //Uniquement DD3.5 mod
        {   //Application du malus  l'attaque en fonction des blessures
            if(cmb->malus[cmb->num] < 0)    //Si malus  l'attaque
                printf(", malus de %d", cmb->malus[cmb->num]);
        }
        printf("): +");
        for(i=0;i<20;i++)
            copie_battaques[i] = cmb->battaques[cmb->num][cmb->arme[cmb->num]][i];  /*Copie de sauvegarde des jets d'attaque par defaut*/
        loc = cmb->arme0[cmb->num][cmb->arme[cmb->num]][1];  /*Copie de sauvegarde du nombre de jets d'attaque par defaut*/
        cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] = interpret_attaque(saisie,cmb->battaques[cmb->num][cmb->arme[cmb->num]],cmb);
        if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] == 0) /*Pas de saisie, valeur par defaut*/
        {   /*Reprend les copies*/
            for(i=0;i<20;i++)
                cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] = copie_battaques[i];
            cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] = loc;
        }
        i=0;
        if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] == -1)  //Si interpret_attaque renvoi -1, changement d'arme
        {
            cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] = loc; //Reprend le nombre d'attaque avant le changement d'arme (au cas o le programme quitte avant de revenir ici)
            choix_arme(cmb);
            i=1;    //Indique un changement d'arme pour la boucle while.
        }
    }while(i); //i = 1, c'est un changement d'arme. Reboucle pour utiliser la nouvelle arme.
    do
    {    /*Boucle d'erreur de saisie*/
        if(p35) //En pur 3.5, on attaque la CA
            printf("CA de l'adversaire (Defaut=%d): ", cmb->defaut[cmb->num][0]);
        else    //En 3.5 mod, on attaque d'abord l'esquive
            printf("Esquive de l'adversaire (Defaut=%d): ", cmb->defaut[cmb->num][0]);
        esquiv = (int) interpret_calc("\0",0);
        if(esquiv==QUIT)
            Quitter(cmb);
    } while (esquiv == NA);
    if(esquiv == defo)  /*Si pas d'entre, valeur par defaut*/
        esquiv = cmb->defaut[cmb->num][0];
    else /*Si esquiv spcifie*/
        cmb->defaut[cmb->num][0] = esquiv; /*Devient la valeur par defaut*/
    for (i=0;i<cmb->arme0[cmb->num][cmb->arme[cmb->num]][1];i++)
    {
        if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][5]==2) //Dans le cas d'une attaque  armes multiples
        {   //L'arme utilise pour cette attaque va tre duplique dans les caractristiques de l'arme spciale 'attaque  arme multiple'
            putsacc("\nAttaque  armes multiples, utilisation de l'arme ");
            printf("%s.\n", cmb->nom_arme[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]]);
            cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] = cmb->arme0[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]][2];    //Copie du critique de l'arme
            cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] = cmb->arme0[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]][3];    //Copie du bonus de perforation
            cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] = cmb->arme0[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]][4];    //Copie du bonus de dgts
            strcpy(cmb->degats[cmb->num][cmb->arme[cmb->num]],cmb->degats[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]]);        //Copie des dgts de l'arme
            strcpy(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],cmb->effet_arme[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]]);        //Copie de l'effet de l'arme
            strcat(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],"|"); //Concatne  l'effet, un pipe
            strcat(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],cmb->nom_arme[cmb->num][cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i]]); //Puis le nom
            //Le principe est le suivant, on va chercher les valeurs de l'arme utilise pour cette attaque, parmis les armes utilises pour l'attaque  armes multiples, et on va les copier dans le tableau de l'attaque  armes multiples. Ainsi,  chaque attaque (chaque boucle du for), les carac de l'arme change pour correspondre  celle qui est utilise.
        }
        cmb->crit_tete[0]=0; //Initialise le potentiel critique.
        cmb->crit_tete[1]=0; //Initialise la potentielle attaque  la tte.
        jet_att = NbAlea1b(20);   /*Effectue le jet de d20 du jet d'attaque*/
        printf("\nJet naturel= %d\n", jet_att);
        if (jet_att > 1)  /*Si c'est pas un critique*/
        {
            if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] == 0 || (cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] && jet_att>= cmb->arme0[cmb->num][cmb->arme[cmb->num]][2]))
            {   //Si critique non renseign OU critique renseign ET jet naturel ok pour un critique, effectue la confirmation de critique
                printf("Confirmation critique ");
                jet_perf = NbAlea1b(20) + cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] + cmb->malus[cmb->num]; //Utilise jet_perf pour stocker temporairement la vrif du critique
                printf("(%d): ", jet_perf);
                if (jet_perf < esquiv)
                    printf("non\n");
                else
                {
                    printf("OK !\n");
                    if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] == 0)   //Critique non renseign, valeur par dfaut de 19
                    {
                        if(jet_att > 18)    //Si le jet naturel est  19 ou 20 et que le critique est confirm, indique un critique potentiel pour cette attaque.
                            cmb->crit_tete[0]=jet_att;
                    }
                    else    //Critique renseign pour cette arme
                    {
                        if(jet_att >= cmb->arme0[cmb->num][cmb->arme[cmb->num]][2])    //Si le jet naturel est gal ou dpasse la valeur de critique et que le critique est confirm, indique un critique VALIDE pour cette attaque.
                            cmb->crit_tete[0]=jet_att;
                    }
                }
            }
            printf(">%s %d\n", acc("Jet modifi=",chfunc), jet_att+cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] + cmb->malus[cmb->num]);
            if (jet_att+cmb->battaques[cmb->num][cmb->arme[cmb->num]][i]+cmb->malus[cmb->num] < esquiv)
            {
                putsacc("\n->L'attaque a rate l'adversaire\n");
            }
            else
            {
                if(p35) //En pur 3.5, si l'attaque touche, l'attaque est russi.
                    putsacc("\n***** Attaque russie, l'adversaire est bless *****\n");
                else    //En 3.5 mod, il faut encore perforre l'armure
                    putsacc("\n->L'attaque a touche l'adversaire.\n");
                loc = NbAlea1b(20);   /*Jet de lacalisation*/
                printf("Localisation de l'impact: %d  (pour un %s: ", loc, acc("humanode",chfunc));
                if (loc <= 5)        /*Localisation humanode*/
                    puts("Jambes)");
                if (loc >= 6 && loc <= 12)
                    puts("Torse)");
                if (loc >= 13 && loc <= 15)
                    puts("Bras gauche)");
                if (loc >= 16 && loc <= 18)
                    puts("Bras droit)");
                if (loc == 19 || loc == 20)
                {
                    putsacc("Tte (partie sensible!))\n");
                    cmb->crit_tete[1]=loc;    //Indique que l'attaque touche la tte (Sous condition que ce soit un humanode)
                }
                if(!p35)    //La perforation ne concerne que la version 3.5 mod
                {

                    if(cmb->crit_tete[0] && cmb->arme0[cmb->num][cmb->arme[cmb->num]][2])   //Si critique confirm
                    {
                        putsacc("\n***** L'attaque critique est confirme, la perforation est automatique. *****\n");
                        jet_perf=1; bonus_perf=1; resist=1; //S'assure que la perforation passera.
                    }
                    else
                    {   //Si l'attaque n'est pas un critique, effectue la perforation
                        do
                        {    /*Boucle d'erreur de saisie*/
                            printf("Bonus de perforation (Defaut=%d): +", cmb->arme0[cmb->num][cmb->arme[cmb->num]][4]);
                            bonus_perf = (int) interpret_calc("\0",0);
                            if(bonus_perf==QUIT)
                                Quitter(cmb);
                        } while (bonus_perf == NA);
                        if(bonus_perf == defo)  /*Si pas d'entre, valeur par defaut*/
                            bonus_perf = cmb->arme0[cmb->num][cmb->arme[cmb->num]][4];
                        else /*Si bonus_perf spcifi*/
                            cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] = bonus_perf; /*Devient la valeur par defaut*/
                        do
                        {    /*Boucle d'erreur de saisie*/
                            printf("R%ssistance de l'adversaire (Defaut=%d): ", acc("",chfunc),cmb->defaut[cmb->num][1]);
                            resist = (int) interpret_calc("\0",0);
                            if(resist==QUIT)
                                Quitter(cmb);
                        } while (resist == NA);
                        if(resist == defo)  /*Si pas d'entre, valeur par defaut*/
                            resist = cmb->defaut[cmb->num][1];
                        else /*Si resist spcifie*/
                            cmb->defaut[cmb->num][1] = resist; /*Devient la valeur par defaut*/
                        jet_perf = 0;
                        do
                        {  /*Bcl si critique 20 en perforation*/
                            jet_perf+= NbAlea1b(20);
                        } while (jet_perf == 20);
                        if(jet_perf >= 20)
                            puts("Critique de perforation!!!");
                        printf("\nJet naturel= %d\n", jet_perf);
                        printf(">%s %d\n", acc("Jet modifi=",chfunc), jet_perf+bonus_perf);
                    }
                    if (jet_perf+bonus_perf < resist)
                        putsacc("->L'attaque n'a pas blesse l'adversaire\n");
                    else
                    {
                        putsacc("***** Attaque russie, l'adversaire est bless *****\n");
                        degats(cmb);
                    }
                }
                else    //Pur 3.5; Pas de perforation ncessaire.
                    degats(cmb);
            }
        }
        else
            printf("->!!!!!! Echec critique !!!!!!        Jet critique= %d\n", NbAlea1b(20));
        Pause();
    }
}

int interpret_attaque(char *attaque, int *bonus_att, struct donnees_combat *cmb)
{
    int i, j;
    char calcul[100];
    strcpy(attaque,nomajloc_attaque(chfunc,0));
    if(attaque[0]=='q')
        Quitter(cmb);
    if(strstr(attaque,"A"))
        return -1;  //Renvoi un changement d'arme.
    i=0;
    if(attaque[0] == '\0')  /*Pas de saisie*/
        return 0;
    for(j=0;j<10;j++)
    {
        strcpy(calcul,attaque); //Copie la saisie pour prparer le calcul
        if (strstr(attaque,"/") != NULL)    //Si d'autre attaque ensuite
            calcul[index_ch_first(calcul,"/")] = '\0';  //Coupe la chaine au premier / trouv pour calculer uniquement la premire attaque
        if(calcul[0] == '+')    //Si le calcul du jet d'attaque commence par + (Notation habituelle des jets d'attaques)
            Efface_char(calcul,"+");    //Efface le +
        bonus_att[i++] = (int) interpret_calc(calcul,0);    //Fais calculer le bonus d'attaque par l'interpreteur de calcul
        if (strstr(attaque,"/") == NULL)    //Si il n'y  plus d'attaque
            return i;       //Renvoi le nombre d'attaque
        else
            Efface_char(attaque,"/");   //Se prpare  saisir le prochaine attaque
    }
    return i;
}

void store_combattants (struct donnees_combat *cmb)
{
    FILE* combattants;
    int i,j,k;
    #ifdef WIN32    /*win*/
    system("copy /Y Combattants.st Combattants.st.backup");     //Crer une copie de sauvegarde avant de rcrire le fichier
    #else /*linux*/
    system("cp Combattants.st Combattants.st.backup");
    #endif
    combattants = ouvre_fichier("Combattants.st","w"); /*Ecrit les donnes dans le fichier*/
    i=0;
    while(i<MAXCOMB)
    {   /*Inscrit les diffrents combattants*/
        if(cmb->nom[i][0] != '\0')
        {
            fprintf(combattants,"#%d\n",i+1);
            fprintf(combattants,"Nom:%s\n", cmb->nom[i]);
            j=0;
            while(j<MAXARMES-1) //Boucle sur les 20 armes
            {
                if(cmb->nom_arme[i][j][0] != '\0')  //Si l'arme est renseigne
                {
                    if(cmb->arme0[i][j][5] == 2) //En cas d'arme multiple, l'inscription est diffrente
                    {
                        fprintf(combattants,">Arme.%d.m\n",j);
                        fprintf(combattants,"-Nom:%s\n",cmb->nom_arme[i][j]);
                        fprintf(combattants,"-Bonus initiative:%d\n",cmb->arme0[i][j][0]);
                        fprintf(combattants,"-Nb attaques:%d\n",cmb->arme0[i][j][1]);
                        for(k=0;k<cmb->arme0[i][j][1] && k<20;k++)
                        {
                            fprintf(combattants,"--Arme utilisee:%d\n",cmb->armesmult[i][j][k]);
                            fprintf(combattants,"--Bonus d'attaque:+%d\n",cmb->battaques[i][j][k]);
                        }
                    }
                    else
                    {
                        fprintf(combattants,">Arme.%d.s\n",j);
                        fprintf(combattants,"-Nom:%s\n",cmb->nom_arme[i][j]);
                        fprintf(combattants,"-Degats:%s\n",cmb->degats[i][j]);
                        fprintf(combattants,"-Bonus degats:%d\n",cmb->arme0[i][j][3]);
                        fprintf(combattants,"-Bonus initiative:%d\n",cmb->arme0[i][j][0]);
                        fprintf(combattants,"-Attaques:");
                        for(k=0;k<cmb->arme0[i][j][1] && k<20;k++)
                        {
                            if(cmb->battaques[i][j][k] > 0)
                                fprintf(combattants,"+");
                            fprintf(combattants,"%d", cmb->battaques[i][j][k]);
                            if(k<cmb->arme0[i][j][1]-1)
                                fprintf(combattants,"/");
                        }
                        fprintf(combattants,"\n");
                        fprintf(combattants,"-Bonus perforation:%d\n",cmb->arme0[i][j][4]);
                        fprintf(combattants,"-Critique:%d\n",cmb->arme0[i][j][2]);
                        fprintf(combattants,"-Effet:%s\n",cmb->effet_arme[i][j]);
                    }
                }
                j++;
            }
            fprintf(combattants,"Arme:%d\n",cmb->arme[i]);
            fprintf(combattants,"Points de vie totaux:%d\n",cmb->tpv[i]);
            fprintf(combattants,"Points de vie actuels:%d\n",cmb->pv[i]);
            fprintf(combattants,"Ds de vie:%s\n",cmb->DV[i]);
            fprintf(combattants,"Bonus pv:%d\n",cmb->bonus_pv[i]);
            //Afin d'viter des erreurs de lecture, suppression des # dans les notes. Il seront remplacs par $
            if(cmb->notes[i] != NULL)   //Seulement si la note est initialise, afin d'viter une erreur
            {
                while(strstr(cmb->notes[i],"#"))    //Tant qu'il y a des #
                {
                    cmb->notes[i][index_ch_first(cmb->notes[i],"#")] = '$';
                };
            }
            fprintf(combattants,"Notes:%s\n#", cmb->notes[i]);
        }
        i++;
    }
    fclose(combattants);
}

void get_combattants (struct donnees_combat *cmb)
{
    FILE* combattants;
    char chaine [255];
    int i;
    //Lecture du fichier Combattants.st
    combattants = ouvre_fichier("Combattants.st","r");
    fgets(chaine,255,combattants);
    while(chaine[0] == '#') //Boucle tant qu'il trouve de nouveaux combattants
    {
        Efface_char(chaine,"#");    //Efface le # qui vient d'tre trouv
        cmb->num = atoi(chaine)-1;   /*Lit le numro du combattant*/
        //Valeur par dfaut pour ce combattant, si certaines infos ne sont pas trouves, il garde les valeurs pas dfaut
        strcpy(cmb->nom[cmb->num],"Sans nom");
        cmb->battaques[cmb->num][0][0] = 1;  //Bonus d'attaque  +1
        cmb->tpv[cmb->num] = 1;  //Total de pv  1
        cmb->pv[cmb->num] = 1;  //Points de vie  1
        cmb->DV[cmb->num][0] = '0';  //DV non renseign
        cmb->DV[cmb->num][1] = '\0';  //DV non renseign
        //Cr la dernire arme, l'arme de dfaut.
        cmb->nom_arme[cmb->num][MAXARMES-1][0] = '\0'; //Nom null.
        strcpy(cmb->degats[cmb->num][MAXARMES-1],"1d6"); //1d6 de dgts.
        cmb->arme0[cmb->num][MAXARMES-1][3] = 0;  //Bonus de dgts  0.
        cmb->arme0[cmb->num][MAXARMES-1][0] = 0; // Initiative de l'arme  0.
        cmb->arme0[cmb->num][MAXARMES-1][1] = 1; //1 seule attaque.
        cmb->battaques[cmb->num][MAXARMES-1][0] = 1; //Attaque  +1.
        cmb->arme0[cmb->num][MAXARMES-1][4] = 0; //Bonus de perforation de l'arme  0.
        cmb->arme0[cmb->num][MAXARMES-1][2] = 19; //Valeur de critique  19.
        cmb->effet_arme[cmb->num][MAXARMES-1][0] = '\0'; //Pas d'effet pour cette arme
        //La note n'est pas initilise, elle restera null si elle n'est pas lue aprs.
        for(i=0;i<MAXARMES-1;i++)   //Initialise le nom des armes
            cmb->nom_arme[cmb->num][i][0] = '\0';
        while((fgets(chaine,255,combattants) != NULL) && chaine[0] != '#')
        {   //Boucle tant que ce n'est pas la fin du fichier ou un # en dbut de ligne
            if(strstr(chaine,"Nom:") != NULL)
            {   //Nom du combattant
                Efface_n(chaine);      //Retire le \n
                Efface_char(chaine,":");
                strcpy(cmb->nom[cmb->num],chaine);    /*Copie le nom du combattant*/
            }
            if(strstr(chaine,">Arme.") != NULL)
            {   //Dtail des armes
                while(chaine[0] == '>')
                {   //Tant qu'il y a des armes  lire
                    Efface_char(chaine,".");    //Efface le . avant le numero de l'arme
                    cmb->arme[cmb->num] = atoi(chaine);   /*Lit le numro de l'arme*/
                    Efface_char(chaine,".");    //Efface le . avant le type de l'arme
                    if(chaine[0] == 'm')
                        cmb->arme0[cmb->num][cmb->arme[cmb->num]][5] = 2;    //Indique que c'est une attaque  armes multiples
                    else
                        cmb->arme0[cmb->num][cmb->arme[cmb->num]][5] = 1;    //Sinon, indique une arme simple
                    //Valeur par dfaut pour cette arme, si certaines infos ne sont pas trouves, elle garde les valeurs pas dfaut
                    strcpy(cmb->degats[cmb->num][cmb->arme[cmb->num]],"1d4");  //Par dfaut, 1d4 de dgts.
                    cmb->battaques[cmb->num][cmb->arme[cmb->num]][0] = 1;  //Bonus d'attaque  +1
                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] = 0;   //Init  0
                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] = 0;   //Critique  0, ce qui indique que le critique n'est pas renseign
                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] = 0;   //Bonus de dgts  +0
                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] = 0;   //Bonus de perforation  +0
                    cmb->effet_arme[cmb->num][cmb->arme[cmb->num]][0] = '\0'; //Pas d'effet pour cette arme
                    fgets(chaine,255,combattants);
                    if(cmb->arme0[cmb->num][cmb->arme[cmb->num]][5] == 2) //Attaque  armes multiples
                    {
                        //Nom de l'arme
                        Efface_char(chaine,":");
                        Efface_n(chaine);
                        strcpy(cmb->nom_arme[cmb->num][cmb->arme[cmb->num]],chaine);    //Copie le nom de l'arme
                        fgets(chaine,255,combattants);
                        if(strstr(chaine,"-Bonus initiative:") != NULL)
                        {
                            Efface_char(chaine,":");
                            cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] = 1;  /*Bonus d'init  1*/
                            if(chaine[0] == '-')
                            {
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] = -1;  /*Bonus d'init  -1, pour bonus ngatif*/
                                Efface_char(chaine,"-");
                            }
                            cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] *= atoi(chaine);  /*Lit le bonus d'initiative*/
                            fgets(chaine,255,combattants);
                        }
                        Efface_char(chaine,":");
                        cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] = atoi(chaine);    //Lit le nombre d'attaque de cette attaque  armes multiples
                        fgets(chaine,255,combattants);
                        for(i=0;i<cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] && i<20;i++)
                        {
                            Efface_char(chaine,":");
                            cmb->armesmult[cmb->num][cmb->arme[cmb->num]][i] = atoi(chaine);    //Lit le numro de l'arme utilise
                            fgets(chaine,255,combattants);

                            Efface_char(chaine,":");
                            cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] = 1;  //Bonus d'attaque  1
                            if(chaine[0] == '-')
                            {
                                cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] = -1;  //Bonus d'attaque  -1, pour bonus ngatif
                                Efface_char(chaine,"-");
                            }
                            else
                                Efface_char(chaine,"+");
                            cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] *= atoi(chaine);  //Lit le bonus d'attaque
                            fgets(chaine,255,combattants);
                        }
                    }
                    else    //Arme simple
                    {
                        do
                        {   //Lit toutes les infos de l'arme
                            if(strstr(chaine,"-Nom:") != NULL)
                            {
                                Efface_char(chaine,":");
                                Efface_n(chaine);
                                strcpy(cmb->nom_arme[cmb->num][cmb->arme[cmb->num]],chaine);    //Copie le nom de l'arme
                            }
                            else if(strstr(chaine,"-Degats:") != NULL)
                            {
                                Efface_char(chaine,":");
                                Efface_n(chaine);
                                strcpy(cmb->degats[cmb->num][cmb->arme[cmb->num]],chaine);    //Copie les dgts de l'arme
                            }
                            else if(strstr(chaine,"-Bonus degats:") != NULL)
                            {
                                Efface_char(chaine,":");
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] = 1;  /*Bonus de dgts  1*/
                                if(chaine[0] == '-')
                                {
                                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] = -1;  /*Bonus de dgts  -1, pour bonus ngatif*/
                                    Efface_char(chaine,"-");
                                }
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][3] *= atoi(chaine);  /*Lit le bonus de dgts*/
                            }
                            else if(strstr(chaine,"-Bonus initiative:") != NULL)
                            {
                                Efface_char(chaine,":");
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] = 1;  /*Bonus d'init  1*/
                                if(chaine[0] == '-')
                                {
                                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] = -1;  /*Bonus d'init  -1, pour bonus ngatif*/
                                    Efface_char(chaine,"-");
                                }
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] *= atoi(chaine);  /*Lit le bonus d'initiative*/
                            }
                            else if(strstr(chaine,"-Attaques:") != NULL)
                            {
                                Efface_char(chaine,":");    /*Lit les jets d'attaques*/
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][1] = index_ch(chaine,"/",cmb->init)+1; /*Donne le nombre de \ dans la chaine (soit le nombre de jet d'attaque-1) et stocke dans j. cmb.init est utilis pour la fonction, mais ne sert  rien ici*/
                                cmb->battaques[cmb->num][cmb->arme[cmb->num]][0] = 1;  /*Bonus d'attaque  1*/
                                if(chaine[0] == '-')
                                {
                                    cmb->battaques[cmb->num][cmb->arme[cmb->num]][0] = -1;  /*Bonus d'attaque  -1, pour bonus ngatif*/
                                    Efface_char(chaine,"-");
                                }
                                else
                                    Efface_char(chaine,"+");
                                cmb->battaques[cmb->num][cmb->arme[cmb->num]][0] *= atoi(chaine);  /*Lit le bonus d'attaque et le multiplie par 1 ou -1 si ngatif*/
                                for(i=1;i<cmb->arme0[cmb->num][cmb->arme[cmb->num]][1];i++)
                                {
                                    Efface_char(chaine,"/"); /*passe  l'attaque suivante*/
                                    cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] = 1;  /*Bonus d'attaque  1*/
                                    if(chaine[0] == '-')
                                    {
                                        cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] = -1;  /*Bonus d'attaque  -1, pour bonus ngatif*/
                                        Efface_char(chaine,"-");
                                    }
                                    else
                                        Efface_char(chaine,"+");
                                    cmb->battaques[cmb->num][cmb->arme[cmb->num]][i] *= atoi(chaine);  /*Lit le bonus d'attaque et le multiplie par 1 ou -1 si ngatif*/
                                }
                            }
                            else if(strstr(chaine,"-Bonus perforation:") != NULL)
                            {
                                Efface_char(chaine,":");
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] = 1;  /*Bonus de perforation  1*/
                                if(chaine[0] == '-')
                                {
                                    cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] = -1;  /*Bonus de perforation  -1, pour bonus ngatif*/
                                    Efface_char(chaine,"-");
                                }
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][4] *= atoi(chaine);  /*Lit le bonus de perforation*/
                            }
                            else if(strstr(chaine,"-Critique:") != NULL)
                            {
                                Efface_char(chaine,":");
                                cmb->arme0[cmb->num][cmb->arme[cmb->num]][2] = atoi(chaine);  /*Lit le critique*/
                            }
                            if(strstr(chaine,"-Effet:") != NULL)
                            {
                                Efface_char(chaine,":");
                                Efface_n(chaine);
                                strcpy(cmb->effet_arme[cmb->num][cmb->arme[cmb->num]],chaine);    //Copie l'effet de l'arme
                            }
                            fgets(chaine,255,combattants);
                        }while(chaine[0] == '-');
                    }
                };
                Efface_char(chaine,":");
                cmb->arme[cmb->num] = atoi(chaine);  //Lit le numro de l'arme utilise
            }
            else if(strstr(chaine,"totaux") != NULL)
            {   //Points de vie totaux
                Efface_char(chaine,":");
                cmb->tpv[cmb->num] = atoi(chaine);  //Lit le total de points de vie
            }
            else if(strstr(chaine,"actuels") != NULL)
            {   //Points de vie actuels puis notes sur le combattant
                Efface_char(chaine,":");
                cmb->pv[cmb->num] = 1;  //Points de vie  1
                if(chaine[0] == '-')
                {
                    cmb->pv[cmb->num] = -1;  /*pv  -1, pour pv ngatif*/
                    Efface_char(chaine,"-");
                }
                cmb->pv[cmb->num] *= atoi(chaine);  //Lit le nombre de pv actuels
                Etat_combattant(cmb);  //Dtermine l'tat de blessure du combattant

            }
            else if(strstr(chaine,"Ds de vie:") != NULL)
            {   //DV du combattant
                Efface_char(chaine,":");
                Efface_n(chaine);
                strcpy(cmb->DV[cmb->num],chaine);    //Copie les ds de vie
            }
            else if(strstr(chaine,"Bonus pv:") != NULL)
            {   //Bonus de pv au DV
                Efface_char(chaine,":");
                cmb->bonus_pv[cmb->num] = 1;  //Bonus de pv  1
                if(chaine[0] == '-')
                {
                    cmb->bonus_pv[cmb->num] = -1;  //Bonus de pv  -1, pour bonus ngatif
                    Efface_char(chaine,"-");
                }
                cmb->bonus_pv[cmb->num] *= atoi(chaine);  //Lit le bonus de pv
            }
            else if(strstr(chaine,"Notes:") != NULL)
            {   //Notes
                #ifdef WIN32    /*win*/
                fseek(combattants,0,1);     //Comportement trange sous win! On recule le curseur de 0, mais sans fseek, le cruseur n'est pas  la bonne place... Illogique...
                #else /*linux*/
                fseek(combattants,-strlen(chaine),1);   //Recule le curseur du fichier jusqu'au dbut de la saisie
                #endif
                cmb->notes[cmb->num] = tabch_dyn(cmb->notes,cmb->num,combattants,'#'); //Lit les notes sur le combattant
                Efface_char(cmb->notes[cmb->num],":");
            }
        }
    }
    fclose(combattants);
}

void Etat_combattant (struct donnees_combat *cmb)
{
//?: Plus de pv que le max; I: Indemne; -2: Blessure lgre; -4: Blessure grave; -6: Handicap; -8: Hmorragie; x: Coma; t: Mort
    float PV;
    PV = cmb->tpv[cmb->num]; //Prend le nombre de points de vie totaux
    if(cmb->pv[cmb->num] > cmb->tpv[cmb->num])
        cmb->etat[cmb->num] = '?';  //Etat indtermin
    if(cmb->pv[cmb->num] == cmb->tpv[cmb->num])
        cmb->etat[cmb->num] = 'I';  //Indemne
    else
    {
        if(cmb->pv[cmb->num] < -9)
            cmb->etat[cmb->num] = 't';  //Mort
        else
        {
            if(cmb->pv[cmb->num] < 1)
                cmb->etat[cmb->num] = 'x';  //Coma
            else
            {
                if(p35) //pur 3.5
                {
                    if(cmb->pv[cmb->num] < cmb->tpv[cmb->num])
                        cmb->etat[cmb->num] = '/';    //Bless
                }
                else    //3.5 mod
                {
                    if(cmb->pv[cmb->num] <= floor(PV/5))
                        cmb->etat[cmb->num] = -8;    //Hmorragie
                    else
                    {
                        if(cmb->pv[cmb->num] <= floor(PV/5*2))
                            cmb->etat[cmb->num] = -6;    //Handicap
                        else
                        {
                            if(cmb->pv[cmb->num] <= floor(PV/5*3))
                                cmb->etat[cmb->num] = -4;   //Blessure grave
                            else
                            {
                                if(cmb->pv[cmb->num] <= floor(PV/5*4))
                                    cmb->etat[cmb->num] = -2;   //Blessure lgre
                                else
                                {
                                    if(cmb->pv[cmb->num] < PV)
                                        cmb->etat[cmb->num] = 0;    //Egratignure
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    if(cmb->etat[cmb->num] < 1)
        cmb->malus[cmb->num] = cmb->etat[cmb->num]; //Si malus  l'attaque, prend le malus
    else
        cmb->malus[cmb->num] = 0;   //Si pas de malus, malus  0.
}

int saisie_pv (struct donnees_combat *cmb)
{
    FILE* sortie;
    int pv;
    char cmdsys[255];
    strcpy(cmdsys,nomajloc_des(chfunc,0));
    if(cmdsys[0]=='q')
        return QUIT;
    if(!cmdsys[0])
        return defo;  //Chaine vide
    if(!strstr(cmdsys,"d"))   //Pas de jet de ds a effectuer.
    {
        pv = atoi(cmdsys);
        cmb->DV[cmb->num][0] = '0'; //DV non renseigns
        cmb->DV[cmb->num][1] = '\0'; //DV non renseigns
    }
    else
    {
        strcpy(cmb->DV[cmb->num],cmdsys);
        do
        {    /*Bcl erreur saisie*/
            putsacc("Bonus de PV  appliquer: +");
            cmb->bonus_pv[cmb->num] = (int) interpret_calc("\0",0);
            if(cmb->bonus_pv[cmb->num]==QUIT)
                return QUIT;
        } while (cmb->bonus_pv[cmb->num] == NA || cmb->bonus_pv[cmb->num] == defo);
        #ifdef WIN32    /*win*/
        sprintf(cmdsys,"cd \"..\\Programmes divers\" && PV.exe p35=%d  NbCreature=1 NbJet=3 Des=\"%s\" Bonus=%d Affichage=3", p35, cmb->DV[cmb->num], cmb->bonus_pv[cmb->num]);
        #else /*linux*/
        sprintf(cmdsys,"cd \"../Programmes divers\" && ./PV p35=%d  NbCreature=1 NbJet=3 Des=\"%s\" Bonus=%d Affichage=3", p35, cmb->DV[cmb->num], cmb->bonus_pv[cmb->num]);
        #endif
        system(cmdsys); /*Appel le gnrateur de points de vie en ligne de commande*/
        sortie = ouvre_fichier("..\\Programmes divers\\Sortie_pv.txt","r");
        fgets(cmdsys,255,sortie);  /*Lit le rsultat du points de vie*/
        Efface_char(cmdsys,": ");
        pv = atoi(cmdsys);
        fclose(sortie);
    }
    return pv;
}

void choix_arme (struct donnees_combat *cmb)
{
    int i, j, arme, sm, M=0, old_init, defautA, amOK;
    int copie_battaques[20];
    char choix[10];
    char chaine[255];
    do
    {
        printf("\nChoix de l'arme pour %s:\n", cmb->nom[cmb->num]);
        printf("mX = Modifier arme; sX = Supprimer arme; X = Choisir arme; add = Ajouter arme.\n");
        putsacc("am = Ajouter une attaque  armes multiples (Ncessite au moins 2 armes).\n");
        sm=0;   //Par dfaut, sm=0, pas de demande de suppression , de modif d'arme ou d'ajout d'arme
        i=0;
        printf("Arme actuelle: Arme %d, %s\n",cmb->arme[cmb->num],cmb->nom_arme[cmb->num][cmb->arme[cmb->num]]);
        amOK=0; //Par dfaut, l'armes multiples n'est pas valid
        while(i<MAXARMES-1) //Boucle sur les 20 armes
        {
            if(cmb->nom_arme[cmb->num][i][0] != '\0')  //Si l'arme est renseigne
            {
                printf("%d) ",i);
                if(cmb->arme0[cmb->num][i][5] == 2)
                    printf("(m) "); //En cas d'attaque  armes multiples, indique par (m)
                else
                    amOK++; //Si ce n'est pas une arme multiple, compte comme une arme simple.
                printf("Arme %d, %s\n",i,cmb->nom_arme[cmb->num][i]);
            }
            i++;
        };
        if (amOK>=2)
            amOK=1; //Au moins 2 armes pour autoriser l'armes multiples.
        else
            amOK=0;
        do
        {
            if(cmb->arme[cmb->num] == 0 && !strcmp(cmb->nom_arme[cmb->num][0],"_default_")) //Si le combattant utilise l'arme 0 et qu'elle s'appelle _default_
            {   //C'est que l'arme 0 est par dfaut et non renseigne
                strcpy(choix,"add");    //Force  l'ajout d'une arme directement
            }
            else
            {   //Sinon menu normal et demande  l'utilisateur
                printf("?: ");
                strcpy(choix,nomajloc_choix_arme(chfunc,0));
            }
            if(choix[0]=='q')
                Quitter(cmb);
            if(choix[0] == 's')
            {
                Efface_char(choix,"s");
                arme = atoi(choix);
                sm=1;
            }
            else if(choix[0] == 'm')
            {
                Efface_char(choix,"m");
                arme = atoi(choix);
                if(cmb->arme0[cmb->num][arme][5] == 2)
                    sm=5;  //armes multiples
                else
                    sm=2;   //Arme simple
            }
            else if(choix[0] == 'a' && choix[1] == 'd' && choix[2] == 'd')  //Ajout d'arme
                sm=3;
            else if(choix[0] == 'a' && choix[1] == 'm' && amOK)  //Ajout d'une attaque  armes multiples, sous condition que le nombre d'armes renseignes soit suffisant
                sm=4;
            else if(isdigit(choix[0]))  //Si c'est un chiffre
                arme = atoi(choix);
            else    //Saisie non comprise
                choix[0] = '\0';
            if(sm!=3 && sm!=4 && choix[0]!='\0')
            {   //Pour l'ajout d'arme ou d'armes multiples, on ne donne pas de numro d'arme  vrifier.
                if(cmb->nom_arme[cmb->num][arme][0] == '\0')   //L'arme demande n'existe pas
                    choix[0] = '\0';
            }
        }while(choix[0] == '\0');   //Reboucle sur une saisie errone
        if(sm==1)   //Suppression de l'arme
        {
            i=0;
            j=0;
            while(i<MAXARMES-1) //Boucle sur les 20 armes
            {
                if(cmb->nom_arme[cmb->num][i][0] != '\0')  //Si l'arme est renseigne
                    j++;    //Compte le nombre d'armes renseignes
                i++;
            };
            if(j>1) //Si il y a plus d'une arme
                cmb->nom_arme[cmb->num][arme][0] = '\0';    //Supprime l'arme
            else
                printf("Impossible de supprimer l'arme %d, il doit en rester au moins une.\n", arme);
            puts("");
            M=1;
        }
        else if(sm==2 || sm==3)  //Modification de l'arme ou ajout d'arme
        {
            defautA=0;  //Valeur par dfaut pour forcer le choix du dfaut
            if(sm==3)   //Ajout
            {
                for(arme=0;arme<MAXARMES-1;arme++)
                {
                    if(arme == 0 && !strcmp(cmb->nom_arme[cmb->num][0],"_default_")) //Si l'arme 0 s'appelle _default_
                    {
                        defautA = MAXARMES-1;   //Si c'est la premire arme, prend l'arme par dfaut pour les valeurs par dfaut
                        break;  //Prend l'emplacement 0
                    }
                    if(cmb->nom_arme[cmb->num][arme][0] == '\0')
                        break;  //Cherche un espace libre pour la nouvelle arme
                }
            }
            if(arme>=MAXARMES-1) //Ceci peut arriver lors de la recherche d'un emplacement uniquement.
                putsacc("Aucun espace disponible, supprimer une arme au pralable\n");
            else
            {
                if(!defautA && sm==3)  //Si ce n'est pas la premire arme  entrer et que c'est un ajout d'arme
                {   //Prend une arme valable pour dterminer les valeurs par dfaut
                    defautA = MAXARMES-1; //Valeur par dfaut, par scurit
                    i=MAXARMES-2;   //Commence par la fin pour prendre les armes ajoutes en dernier
                    while(i>=0) //Boucle sur les 20 armes
                    {
                        if(cmb->nom_arme[cmb->num][i][0] != '\0')  //Si l'arme est renseigne
                        {
                            defautA = i;
                            break;
                        }
                        i--;
                    }; //Si il ne trouve rien, ce qui est thoriquement impossible. Il restera sur -1.
                }
                if(sm==2)   //Modif
                    defautA = arme; //Pour une modif d'arme, on prend en dfaut les valeurs de l'arme  modifier
                if(sm==2)   //Modif
                    printf("Modification de l'arme %d.\n", arme);
                if(sm==3)   //Ajout
                    printf("\nAjout d'une nouvelle arme, l'arme %d.\n", arme);
                cmb->arme0[cmb->num][arme][5] = 1; //Indique que c'est une arme simple (surtout utile pour une nouvelle arme)
                printf("Nom de l'arme (Defaut=%s): ", acc(cmb->nom_arme[cmb->num][defautA],chfunc));
                getsfix(chaine,255);
                if(chaine[0] != '\0')   //Si un nouveau nom est entr
                    strcpy(cmb->nom_arme[cmb->num][arme],chaine);
                else if(sm==3)   //valeur par dfaut pour ajout
                    strcpy(cmb->nom_arme[cmb->num][arme],cmb->nom_arme[cmb->num][defautA]); //Prend la valeur par dfaut
                putsacc("Dgts de l'arme");
                printf(" (Defaut=%s): ", cmb->degats[cmb->num][defautA]);
                strcpy(chaine,nomajloc_des(chfunc,0));
                if(choix[0]=='q')
                    Quitter(cmb);
                if(chaine[0] != '\0')   //Si des nouveaux dgts sont entrs
                    strcpy(cmb->degats[cmb->num][arme],chaine);
                else if(sm==3)   //valeur par dfaut pour ajout
                    strcpy(cmb->degats[cmb->num][arme],cmb->degats[cmb->num][defautA]); //Prend la valeur par dfaut
                do
                {    /*Boucle d'erreur de saisie*/
                    putsacc("Bonus de dgts");
                    printf(" (Defaut=%d): +", cmb->arme0[cmb->num][defautA][3]);
                    i = (int) interpret_calc("\0",0);
                    if(i==QUIT)
                        Quitter(cmb);
                } while (i == NA);
                if(i != defo)  /*Si nouveau bonus de dgts*/
                    cmb->arme0[cmb->num][arme][3] = i; /*Devient la valeur par defaut*/
                else if(sm==3)   //valeur par dfaut pour ajout
                    cmb->arme0[cmb->num][arme][3] = cmb->arme0[cmb->num][defautA][3];  //Prend la valeur par dfaut
                do
                {    /*Boucle d'erreur de saisie*/
                    printf("Initiative de l'arme (Defaut=%d): +", cmb->arme0[cmb->num][defautA][0]);
                    i = (int) interpret_calc("\0",0);
                    if(i==QUIT)
                        Quitter(cmb);
                } while (i == NA);
                if(i != defo)  /*Si nouveau bonus d'initiative*/
                    cmb->arme0[cmb->num][arme][0] = i; /*Devient la valeur par defaut*/
                else if(sm==3)   //valeur par dfaut pour ajout
                    cmb->arme0[cmb->num][arme][0] = cmb->arme0[cmb->num][defautA][0];    //Prend la valeur par dfaut
                printf("Bonus d'attaque (Defaut:");
                for(i=0;i<cmb->arme0[cmb->num][defautA][1] && i<20;i++) /*bcl sur le nombre d'attaque pour l'affichage*/
                {
                    if(i>0)
                        printf("\\");
                    if(cmb->battaques[cmb->num][defautA][i] >= 0)
                        printf("+");
                    printf("%d", cmb->battaques[cmb->num][defautA][i]);
                }
                printf("): +");
                for(i=0;i<20;i++)
                    copie_battaques[i] = cmb->battaques[cmb->num][defautA][i];  /*Copie de sauvegarde des jets d'attaque par defaut*/
                j = cmb->arme0[cmb->num][defautA][1];  /*Copie de sauvegarde du nombre de jets d'attaque par defaut*/
                cmb->arme0[cmb->num][arme][1] = interpret_attaque(chaine,cmb->battaques[cmb->num][arme],cmb);
                if(cmb->arme0[cmb->num][arme][1] == 0) /*Pas de saisie, valeur par defaut*/
                {   /*Reprend les copies*/
                    for(i=0;i<20;i++)
                        cmb->battaques[cmb->num][arme][i] = copie_battaques[i];
                    cmb->arme0[cmb->num][arme][1] = j;
                }
                do
                {    /*Boucle d'erreur de saisie*/
                    printf("Bonus de perforation (Defaut=%d): +", cmb->arme0[cmb->num][defautA][4]);
                    i = (int) interpret_calc("\0",0);
                    if(i==QUIT)
                        Quitter(cmb);
                } while (i == NA);
                if(i != defo)  /*Si nouveau bonus de perforation*/
                    cmb->arme0[cmb->num][arme][4] = i; /*Devient la valeur par defaut*/
                else if(sm==3)   //valeur par dfaut pour ajout
                    cmb->arme0[cmb->num][arme][4] = cmb->arme0[cmb->num][defautA][4];  //Prend la valeur par dfaut
                do
                {    /*Boucle d'erreur de saisie*/
                    putsacc("La valeur de critique est la limite infrieure du critique de l'arme.\nPar exemple 19 pour un critique 19-20.\n");
                    printf("Valeur de critique de l'arme (Defaut=%d): ", cmb->arme0[cmb->num][defautA][2]);
                    i = (int) interpret_calc("\0",0);
                    if(i==QUIT)
                        Quitter(cmb);
                } while (i == NA);
                if(i != defo)  /*Si nouveau critique*/
                    cmb->arme0[cmb->num][arme][2] = i; /*Devient la valeur par defaut*/
                else if(sm==3)   //valeur par dfaut pour ajout
                    cmb->arme0[cmb->num][arme][2] = cmb->arme0[cmb->num][defautA][2];  //Prend la valeur par dfaut
                printf("Effet particulier de l'arme (Defaut=%s): ", acc(cmb->effet_arme[cmb->num][defautA],chfunc));
                getsfix(chaine,255);
                if(chaine[0] != '\0')   //Si un nouvel effet est entr
                    strcpy(cmb->effet_arme[cmb->num][arme],chaine);
                else if(sm==3)   //valeur par dfaut pour ajout
                    strcpy(cmb->effet_arme[cmb->num][arme],cmb->effet_arme[cmb->num][defautA]); //Prend la valeur par dfaut
            }
            M=1;
        }
        else if(sm==4)  //Ajout d'une attaque  armes multiples
        {
            for(arme=0;arme<MAXARMES-1;arme++)  //Cherche un emplacement pour l'armes multiples parmi les armes normales.
            {
                if(cmb->nom_arme[cmb->num][arme][0] == '\0')
                    break;  //Cherche un espace libre pour la nouvelle arme
            }
            if(arme>=MAXARMES-1)
                putsacc("Aucun espace disponible, supprimer une arme au pralable\n");
            else
            {
                cmb->arme0[cmb->num][arme][5] = 2; //Indique que cette arme est un champs d'armes multiples.
                putsacc("Ajout d'une attaque  armes multiples");
                printf(", en tant que arme %d.\n", arme);
                putsacc("Nom de l'attaque  armes multiples: ");
                getsfix(cmb->nom_arme[cmb->num][arme],255);
                for(i=0;i<MAXARMES-1;i++)
                {
                    printf("\nChoix de l'arme pour l'attaque %d:\n", i+1);
                    do
                    {
                        j=0;
                        while(j<MAXARMES-1) //Boucle sur les 20 armes
                        {
                            if(cmb->nom_arme[cmb->num][j][0] != '\0' && cmb->arme0[cmb->num][j][5] != 2)  //Si l'arme est renseigne et que ce n'est pas une attaque  armes mutiples.
                                printf("%d) Arme %d, %s\n",j,j,cmb->nom_arme[cmb->num][j]);
                            j++;
                        };
                        printf("?: ");
                        amOK = chiffre_lettre(0);   //Prend la saisie
                        if(amOK == QUIT)
                            Quitter(cmb);
                    }while(amOK > j);    //Si l'arme n'existe pas, reboucle.
                    cmb->armesmult[cmb->num][arme][i] = amOK;    //L'arme choisie est slectionne.
                    do
                    {
                        printf("Bonus d'attaque avec cette arme (Defaut=+%d): +", cmb->battaques[cmb->num][amOK][0]);
                        j = (int) interpret_calc("\0",0);
                        if(j==QUIT)
                            Quitter(cmb);
                    } while (j == NA);
                    if(j == defo)   //valeur par dfaut
                        cmb->battaques[cmb->num][arme][i] = cmb->battaques[cmb->num][amOK][0];    //Prend la valeur par dfaut
                    else
                        cmb->battaques[cmb->num][arme][i] = j; //Prend la valeur note
                    if(i)
                    {
                        putsacc("Ajouter une attaque supplmentaire? (O/N, non par dfaut): ");
                        j = getchar();
                        if(j != 10)
                            getchar(); //Absorbe entre
                        if (j != 79 && j != 111)    //79=O; 111=o
                            break;  //Sortie de la boucle
                    }
                }
                //Init de l'attaque  armes multiples = init de la premire arme.
                cmb->arme0[cmb->num][arme][0] = cmb->arme0[cmb->num][cmb->armesmult[cmb->num][arme][0]][0]; //Init de la premire arme
                //Nombre d'attaques dans l'attaque  armes multiples
                cmb->arme0[cmb->num][arme][1] = i+1;
            }
            M=1;
        }
        else if(sm==5)  //Modification d'une attaque  armes multiples
        {
            putsacc("\nNom de l'attaque  armes multiples ");
            printf("(Defaut=%s): ", acc(cmb->nom_arme[cmb->num][arme],chfunc));
            getsfix(chaine,255);
            if(chaine[0] != '\0')   //Si un nouveau nom est entr
                strcpy(cmb->nom_arme[cmb->num][arme],chaine);
            do
            {
                putsacc("\nModification de l'attaque  armes multiples ");
                printf("%s:\n", acc(cmb->nom_arme[cmb->num][arme],chfunc));
                printf("mX = Modifier attaque; sX = Supprimer attaque; add = Ajouter attaque.\n");
                printf("dXdY = Intervertir attaque X et Y; q = Retour.\n");
	            for(i=0;i<cmb->arme0[cmb->num][arme][1];i++)    //Boucle sur le nombre d'attaque
                {
                    printf("%d) ",i+1);  //Indique le numro de menu
                    printf("Attaque %d, %s",i+1,cmb->nom_arme[cmb->num][cmb->armesmult[cmb->num][arme][i]]); //Indique le nom de l'arme
                    printf(" (+%d)\n",cmb->battaques[cmb->num][arme][i]);    //Bonus d'attaque avec cette arme
                }
                printf("?: ");
                strcpy(choix,nomajloc_choix_arme(chfunc,0));
                sm=0;
                if(choix[0] == 's')
                {   //Supression attaque
                    Efface_char(choix,"s");
                    defautA = atoi(choix)-1;
                    sm=101;
                }
                else if(choix[0] == 'm')
                {   //Modification attaque
                    Efface_char(choix,"m");
                    defautA = atoi(choix)-1;
                    sm=102;
                }
                else if(choix[0] == 'a' && choix[1] == 'd' && choix[2] == 'd')  //Ajout d'une attaque
                    sm=103;
                else if(choix[0] == 'd')
                {   //Dplacement d'attaque
                    Efface_char(choix,"d");
                    defautA = atoi(choix)-1;
                    Efface_char(choix,"d");
                    j = atoi(choix)-1;
                    sm=104;
                }
                if(sm==101)
                {
                    printf("Suppression de l'attaque %d.\n", defautA);
                    for(i=defautA;i<19;i++)
                    {
                        cmb->armesmult[cmb->num][arme][i] = cmb->armesmult[cmb->num][arme][i+1];    //Ecrase et dplace toutes les attaques suivante celle qui est supprime
                        cmb->battaques[cmb->num][arme][i] = cmb->battaques[cmb->num][arme][i+1];    //Fais de mme avec les bonus d'attaque.
                    }
                    cmb->arme0[cmb->num][arme][1]--; //Dcrmente le nombre d'attaque
                }
                if(sm==102 || sm==103)
                {
                    //102 = modif, 103 = ajout
                    if(sm==103 && cmb->arme0[cmb->num][arme][1] == MAXARMES-1)
                        puts("Impossible d'ajouter une attaque, maximum atteint.");
                    else
                    {
                        if(sm==103)
                            defautA = cmb->arme0[cmb->num][arme][1];    //Si ajout, l'attaque ajoute est  la suite des prcdentes
                        printf("\nChoix de l'arme pour l'attaque %d:\n", defautA);
                        do
                        {
                            j=0;
                            while(j<MAXARMES-1) //Boucle sur les 20 armes
                            {
                                if(cmb->nom_arme[cmb->num][j][0] != '\0' && cmb->arme0[cmb->num][j][5] != 2)  //Si l'arme est renseigne et que ce n'est pas une attaque  armes mutiples.
                                printf("%d) Arme %d, %s\n",j,j,cmb->nom_arme[cmb->num][j]);
                                j++;
                            };
                            printf("?: ");
                            amOK = chiffre_lettre(0);   //Prend la saisie
                            if(amOK == QUIT)
                                Quitter(cmb);
                        }while(amOK > j);    //Si l'arme n'existe pas, reboucle.
                        cmb->armesmult[cmb->num][arme][defautA] = amOK;    //L'arme choisie est slectionne.
                        printf("Bonus d'attaque avec cette arme: +");
                        cmb->battaques[cmb->num][arme][defautA] = interpret_calc("\0",0);
                        if(cmb->battaques[cmb->num][arme][i]==QUIT)
                        Quitter(cmb);
                        if(sm==103)
                            cmb->arme0[cmb->num][arme][1]++; //Dcrmente le nombre d'attaque
                    }
                }
                if(sm==104)
                {
                    putsacc("Dplacement de l'attaque ");
                    printf("%d", defautA);
                    putsacc("  la place de l'attaque ");
                    printf("%d.\n", j);
                    i = cmb->armesmult[cmb->num][arme][defautA];    //i prend le numro de l'arme defautA
                    cmb->armesmult[cmb->num][arme][defautA] = cmb->armesmult[cmb->num][arme][j]; //le numro de l'arme j passe en defautA
                    cmb->armesmult[cmb->num][arme][j] = i;  //La sauvegarde defautA en i passe en j.
                    i = cmb->battaques[cmb->num][arme][defautA];    //i prend le bonus d'attaque de l'arme defautA
                    cmb->battaques[cmb->num][arme][defautA] = cmb->battaques[cmb->num][arme][j]; //le bonus d'attaque de l'arme j passe en defautA
                    cmb->battaques[cmb->num][arme][j] = i;  //La sauvegarde defautA en i passe en j.
                }
            }while(choix[0] != 'q');
            //Init de l'attaque  armes multiples = init de la premire arme.
            cmb->arme0[cmb->num][arme][0] = cmb->arme0[cmb->num][cmb->armesmult[cmb->num][arme][0]][0]; //Init de la premire arme
            M=1;
        }
        else    //Simple choix d'arme
        {
            old_init = cmb->arme0[cmb->num][cmb->arme[cmb->num]][0];   //old_init prend le modif d'init de l'arme avant changement.
            cmb->arme[cmb->num] = arme; //Change l'arme utilise
            i = cmb->arme0[cmb->num][cmb->arme[cmb->num]][0] - old_init; //Le changement d'init correspond  nouvelle initiative - ancienne initiative
            printf("L'initiative du combattant, %s, ", cmb->nom[cmb->num]);
            if(!i)
                putsacc("reste inchange.\n");
            if(i<0)
                printf("diminue de %d.\n", i);
            if(i>0)
                printf("augmente de %d.\n", i);
            cmb->init[cmb->num] += i;   //Modifie l'initiative du combattant.
        }
    }while(sm); //Tant que sm n'est pas  0 (modif, suppression ou ajout), il redemande le choix de l'arme.
    if(M)   //Si il y a eu une modification
        store_combattants(cmb);
}

void Quitter (struct donnees_combat *cmb)
{
    int i;
    putsacc("Arrt du programme Gestion combattant.\n");
    store_combattants(cmb);    //Sauvegarde la liste des combattants en quittant
    for(i=0;i<MAXCOMB;i++)
    {
        if(cmb->nom[i][0] != '\0')  //Libre les allocations sur tous les combattants.
            free (cmb->notes[i]);  //Libre la mmoire alloue aux notes sur le combattant
    }
    exit(0);
}

void duplicateComb (struct donnees_combat *cmb)
{
    char nom[255];
    int nouv,i,j;
    for(nouv=0;nouv<MAXCOMB;nouv++)
    {
        if(cmb->nom[nouv][0] == '\0')
            break;  /*Cherche un espace libre pour placer la copie du combattant*/
    }
    if(nouv>MAXCOMB-1)
        putsacc("Aucun espace disponible, supprimer des combattants au pralable\n");
    else
    {
        strcpy(nom,cmb->nom[cmb->num]); //Copie le nom du combattant  dupliquer
        i=strlen(nom);
        while(!isalpha(nom[i]) && !ispunct(nom[i]))   //Cherche l'ventuel numro attribu au nom du combattant, en commenant par la fin
            nom[i--] = '\0';  //Efface le caractre de fin, si ce n'est ni une lettre, ni de la ponctuation. Efface chiffre et espace de la prcdente incrmentation.
        for(i=0,j=1;i<MAXCOMB;i++)
        {
            if(cmb->nom[i][0] != '\0')  //Vrifie chaque nom de combattant
            {    //incrmente de 1 chaque fois qu'il trouve le mme nom que le combattant  dupliquer
                if (strstr(cmb->nom[i],nom) != NULL)
                    j++;
            }
        }
        sprintf(nom,"%s %d", nom, j); //Incrmente le nom du combattant
        strcpy(cmb->nom[nouv],nom);  //Copie le nouveau nom.
        for(i=0;i<MAXARMES;i++)
            strcpy(cmb->degats[nouv][i],cmb->degats[cmb->num][i]);  //Copie les dgts pour chaque arme.
        ER = (int) (cmb->notes[nouv] = (char*) calloc(strlen(cmb->notes[cmb->num]),sizeof(char)));  //Allocation du mme espace pour stocker la copie des notes
        Erreur(1);
        strcpy(cmb->notes[nouv],cmb->notes[cmb->num]);
        for(i=0;i<MAXARMES;i++)
        {
            for(j=0;j<20;j++)
                cmb->battaques[nouv][i][j] = cmb->battaques[cmb->num][i][j];    //Copie chaque attaque de chaque arme.
        }
        cmb->defaut[nouv][0] = cmb->defaut[cmb->num][0];    //Copie la saisie par dfaut pour l'esquive
        cmb->defaut[nouv][1] = cmb->defaut[cmb->num][1];    //Copie la saisie par dfaut pour la rsistance
        cmb->init[nouv] = cmb->init[cmb->num];    //Copie le jet d'initiative du combattant
        cmb->tpv[nouv] = cmb->tpv[cmb->num];    //Copie le total de points de vie
        cmb->pv[nouv] = cmb->pv[cmb->num];    //Copie les points de vie actuels
        strcpy(cmb->DV[nouv],cmb->DV[cmb->num]);    //Copie les DV
        cmb->bonus_pv[nouv] = cmb->bonus_pv[cmb->num];    //Copie le bonus de points de vie
        cmb->malus[nouv] = cmb->malus[cmb->num];    //Copie le malus de stade de blessure
        cmb->etat[nouv] = cmb->etat[cmb->num];    //Copie l'tat du combattant
        cmb->hors_combat[nouv] = cmb->hors_combat[cmb->num];    //Copie l'tat du combattant en combat/hors combat
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][0] = cmb->arme0[cmb->num][i][0];    //Copie l'init de chaque arme
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][1] = cmb->arme0[cmb->num][i][1];    //Copie le nombre d'attaque avec chaque arme
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][2] = cmb->arme0[cmb->num][i][2];    //Copie le critique de chaque arme
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][3] = cmb->arme0[cmb->num][i][3];    //Copie le bonus de dgts de chaque arme
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][4] = cmb->arme0[cmb->num][i][4];    //Copie le bonus de perforation de chaque arme
        for(i=0;i<MAXARMES;i++)
            cmb->arme0[nouv][i][5] = cmb->arme0[cmb->num][i][5];    //Copie le type d'arme, simple ou multiple
        for(i=0;i<MAXARMES;i++)
        {
            if(cmb->arme0[nouv][i][5] == 2) //Si l'arme est une arme multiple
            {
                for(j=0;j<20;j++)
                    cmb->armesmult[nouv][i][j] = cmb->armesmult[cmb->num][i][j];    //Copie chaque arme pour les attaques multiples.
            }
        }
        for(i=0;i<MAXARMES;i++)
            strcpy(cmb->nom_arme[nouv][i],cmb->nom_arme[cmb->num][i]);  //Copie le nom de chaque arme
        for(i=0;i<MAXARMES;i++)
            strcpy(cmb->effet_arme[nouv][i],cmb->effet_arme[cmb->num][i]);  //Copie l'effet de chaque arme
        cmb->arme[nouv] = cmb->arme[cmb->num];    //Copie le numro de l'arme utilise.
    }
}
