/* Programme principal pour Servus domini.
Programm par Maniack Crudelis.
http://www.crudelis.fr
Pour des questions, remarques, suggestions et le support. Rendez-vous sur le forum du site.
Version 3.1.*/
/*Copyright (c) 2008 Herv Cottin. Ce fichier fait partie de Servus domini.

Servus domini est un logiciel libre; vous pouvez le redistribuer et/ou le modifier selon les termes de la GNU General Public License (Licence Publique Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation; soit la version 3 de la licence, soit (comme vous le souhaitez) toute version ultrieure.

Servus domini est distribu dans l'espoir qu'il sera utile, mais SANS LA MOINDRE GARANTIE; pas mme la garantie implicite de COMMERCIABILITE ou d'ADEQUATION A UN BUT PARTICULIER.
Voir la GNU General Public License pour plus de dtails.

Vous devriez avoir reu une copie de la GNU General Public License en mme temps que ce programme; sinon, merci d'crire  la Free Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA02111-1307 USA.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Utilitaire.h"
#include "Menu.h"
#include "Jdr.h"
#include "Fichier.h"
#include "Chaines.h"

int Principale (int argc,char *argv[], int xtermOK);
char* Menu_des (char* fichiermenu, char* lecture);
void chg_menu (char* menu);     //Crer un menu en listant le dossier des fichiers de menu

int main(int argc,char *argv[])
{
    int xtermOK;
    init_historique_saisie();
    xtermOK = system("xterm +hold -e exit");   //Effectue un appel de xterm et le fait quitter immdiatemment. Pour tester sa prsence.
    while(Principale(argc,argv,xtermOK));   //Relance la fonction tant qu'elle ne renvoi pas 0.
    return 0;
}

int Principale (int argc,char *argv[], int xtermOK)
{
    FILE* fichier;
    int i=0,j=0;
    char ligne[250];
    char chemin[150];
    char nomfichier[100];
    char command[250] = " ";
    char pwd[4096];
    system(CLEARSCREEN);
    strcpy(pwd,argv[0]);  //pwd prend le chemin absolu de l'excutable (+ executable)
    #ifdef WIN32    /*win*/
        pwd[index_ch_last(pwd,"\\")] = '\0'; //Coupe le chemin au dernier \ pour ne garder que le chemin
    #else /*linux*/
        pwd[index_ch_last(pwd,"/")] = '\0'; //Coupe le chemin au dernier / pour ne garder que le chemin
    #endif
    strcat(pwd,"\\Couleurs.ini");
    fichier=ouvre_fichier(pwd,"r"); //Ouvre Couleurs.ini pour connaitre le menu utilis
    do
    {
        if(!fgets(ligne,250,fichier))
        {
            putsacc("Erreur, impossible de trouver \"#Menu utilis:\" dans le fichier Couleurs.ini\n");
            Pause();
            exit(0);
        }
        Efface_n(ligne);
    }while(strcmp(ligne,"#Menu utilis:"));  //Cherche la ligne correpondant du menu utilis
    fgets(ligne,250,fichier);   //Prend la ligne suivante, contenant le nom du menu  utiliser
    Efface_n(ligne);
    fclose(fichier);
    strcpy(pwd,argv[0]);  //pwd prend le chemin absolu de l'excutable (+ executable)
    #ifdef WIN32    /*win*/
        pwd[index_ch_last(pwd,"\\")] = '\0'; //Coupe le chemin au dernier \ pour ne garder que le chemin
    #else /*linux*/
        pwd[index_ch_last(pwd,"/")] = '\0'; //Coupe le chemin au dernier / pour ne garder que le chemin
    #endif
    strcat(pwd,"\\Menu de Servus Domini\\");    //Construit le chemin du menu
    strcat(pwd,ligne);
    fichier=ouvre_fichier(pwd,"r"); //Ouvre le menu
    do
    {
        if(!fgets(ligne,250,fichier))
        {
            putsacc("Erreur, impossible de trouver \"##Info de titrage\" dans le fichier de menu\n");
            Pause();
            exit(0);
        }
        Efface_n(ligne);
    }while(strcmp(ligne,"##Info de titrage"));  //Cherche la ligne des infos de titrage
    fgets(nomfichier,250,fichier);   //Prend la ligne suivante, contenant le titre de la fentre
    Efface_n(nomfichier);
    Efface_char(nomfichier,":");
    fgets(ligne,250,fichier);   //Prend la ligne suivante, contenant le titre  afficher
    Efface_n(ligne);
    Efface_char(ligne,":");
    fgets(chemin,250,fichier);   //Prend la ligne suivante, contenant l'identifiant de couleur
    Efface_n(chemin);
    Efface_char(chemin,":");
    fclose(fichier);
    Titre (argc,argv,nomfichier,ligne,color_sd(chemin,chfunc,argv));
    strcpy(ligne,Menu_des(pwd,chfunc));
    /*Gestion des accents dans le menu!*/
    #ifndef WIN32    /*linux*/
    strcpy(ligne,acc(ligne,chfunc));
    #endif
    if(!strcmp(ligne,"CHG_MENU"))
    {   //Changement de menu
        chg_menu(command);
        return 1;   //Recharge le menu et l'affichage
    }
    if(strcmp(ligne,"DES"))     //Si lancement de ds, pas d'xecution de programme
    {
        if (strstr(ligne,"\\") != NULL)
        {
            i = index_ch_last(ligne,"\\");
            strcpy(chemin,ligne);
            chemin[i] = '\0';
            i++;
        }
        else
        {
            chemin[0] = '\0';
            i=0;
        }
        for(j=0;i<(int)strlen(ligne);i++)
            nomfichier[j++] = ligne[i];
        nomfichier[j] = '\0';
        if (chemin[0] != '\0')
        {
            strcpy(command,"cd \"");
            changeslash(chemin);    //Inerse les slash pour linux (le cas chant)
            strcat(command,chemin);
        }
        #ifdef WIN32    /*win*/
        if(strstr(ligne,"xdg-open dir="))
        {   //Commande d'ouverture de dossier
            strcpy(command,"explorer \"");
            strcat(command,nomfichier);
            strcat(command,"\"");
        }
        else
        {
            strcat(command,"\" & ");
            strcat(command,"start ");
            strcat(command,nomfichier);
        }
        #else   //linux
        if(strstr(ligne,"xdg-open dir="))
        {   //Commande d'ouverture de dossier
            strcpy(command,"xdg-open \"./");
            strcat(command,nomfichier);
            strcat(command,"\" 2> temp.tmp");
        }
        else
        {
            strcat(command,"\"; ./");
            strcat(command,nomfichier);

            command[index_ch_first(command,".exe")] = '\0';  //Supprime .exe dans la commande
            Efface_char(nomfichier,".exe");  //Supprime avant .exe (et .exe) dans le nom de fichier pour garder les arguments ventuels
            strcat(command," swxterm");
            strcat(command,nomfichier); //Ajoute  command les arguments d'origine de la commande.
            if(!xtermOK)    //xterm est prsent
                strcat(command," &");   //Redonne la main aprs excution

        }
        #endif
        system(command);
    }
    return 1;
}

char* Menu_des (char* fichiermenu, char* lecture)
{
    FILE* temp;
    FILE* FichierMenu;
    int i, choix=-1; /*Valeur par defaut pour choix*/
    char menu='1';
    char affich [255];
    char cmdsys [255];
    FichierMenu = ouvre_fichier(fichiermenu,"r");
    while (feof(FichierMenu) == 0)
    {
        fgets(lecture,255,FichierMenu);
        if ((strstr(lecture,"menu=") != NULL) && (menu==lecture[5]))   /*Si le menu correspondant est trouv*/
        {
            temp = ouvre_fichier("menu.tmp","w");        /*Fichier temporaire*/
            fgets(lecture,250,FichierMenu);
            printf("\n%s", acc(lecture,chfunc));            /*Titre du menu*/
            fprintf(temp,"m) Changer de menu.\n");  //Inscrit l'entre dans le fichier temporaire
            printf("m) Changer de menu.\n");  //Affiche l'entre  l'cran*/
            fgets(lecture,250,FichierMenu);
            while((strstr(lecture,"menu=") == NULL) && (lecture[0] != '#') && (feof(FichierMenu) == 0))
            {                  /*Tant que le menu n'est pas compltement lu*/
                fprintf(temp,"%s",lecture);  /*Inscrit le menu dans le fichier temporaire*/
                i=0;
                while (lecture[i] != ':')
                {
                    affich[i] = lecture[i];
                    i++;
                }
                affich [i] = '\0';
                printf("%s\n", acc(affich,chfunc));  /*Affiche le menu  l'cran*/
                fgets(lecture,250,FichierMenu);
            }
            fclose(temp);
            temp = ouvre_fichier("menu.tmp","r");  /*Lit le menu actuel dans le fichier temporaire*/
            printf("?: ");
            strcpy(affich,nomajloc_des(chfunc,1));
            if(affich[0] == 'm')
            {
                strcpy(lecture,"CHG_MENU");
                fclose(FichierMenu);
                return lecture;
            }
            if(strstr(affich,"d"))
            {   //Lancement de ds au lieu de choix de menu
                puts("");
                #ifdef WIN32    /*win*/
                sprintf(cmdsys,"cd \".\\Programmes divers\" && Simulateur_des.exe Des=\"%s\" Affichage=2", affich);
                #else /*linux*/
                sprintf(cmdsys,"cd \"./Programmes divers\" && ./Simulateur_des Des=\"%s\" Affichage=2", affich);
                #endif
                system(cmdsys); /*Appel le gnrateur de ds en ligne de commande*/
                Pause();
                strcpy(lecture,"DES");
                return lecture;
            }
            if(affich[0] == '\0')   //Chaine vide = appui sur entre direct
                choix = NA;
            else
                choix = atoi(affich);   /*Prend la saisie de l'utilisateur*/
            if(choix == QUIT)
            {
                fclose(temp);
                fclose(FichierMenu);
                exit(0);
            }
            while (feof(temp) == 0)
            {
                fgets(lecture,250,temp);
                if ((atoi(lecture) == choix) && isdigit(lecture[0]))   /*Vrifie que le nombre correspond au choix*/
                {
                    fclose(temp);
                    Efface_char(lecture,":");
                    if (strstr(lecture,"menu-") == NULL)
                    {                /*Si c'est ne pas un changement de menu*/
                        Efface_n(lecture);      //Retire le \n
                        fclose(FichierMenu);
                        return (lecture);   /*Renvoi la saisi (sans le : et le retour ligne*/
                    }
                    menu = lecture[5];     /*Lit le numero du menu*/
                    rewind(FichierMenu);
                    choix = -1;
                    break;
                }
            }
            if (choix != -1)
            {
                Fuck();
                rewind(FichierMenu);
            }
        }
    }
    printf("Erreur dans le fichier de menu, le menu %c n'a pas %s\n", menu, acc("t trouv.",chfunc));
    fclose(temp);
    fclose(FichierMenu);
    DPause();
    exit(0);
}

void chg_menu (char* menu)
{
    FILE* temp;
    FILE* colorfile;
    char nommenu[255];
    char chaine[255];
    putsacc("\nChoississez le nouveau menu  utiliser.");
    Efface_char(menu,"\\");
    printf(" (Menu actuel:%s)", menu);
    Menu_dossier("Menu de Servus Domini","menu_chg.ini","ini");
    strcpy(nommenu,Menu("menu_chg.ini",chfunc,1,0));
    #ifdef WIN32    //win
    Efface_char(nommenu,"\\");
    #else//linux
    Efface_char(nommenu,"/");
    #endif
    colorfile = ouvre_fichier("Couleurs.ini","r");
    temp = ouvre_fichier("temp","w");
    while(fgets(chaine,255,colorfile))
    {
        if(strstr(chaine,"#Menu utilis:"))  //Cherche la ligne correpondant du menu utilis
        {
            fprintf(temp,"%s", chaine);
            fgets(chaine,255,colorfile);
            fprintf(temp,"%s\n", nommenu);    //Substitue le nouveau nom de menu  l'ancien
        }
        else
            fprintf(temp,"%s", chaine);
    }
    fclose(temp);
    fclose(colorfile);
    remove("Couleurs.ini"); //Supprime le prcdent fichier Couleurs.ini
    rename ("temp","Couleurs.ini"); //Pour le remplacer par le nouveau construit sur le fichier temp
}
